import * as $protobuf from "protobufjs/minimal";

/** 시스템 에러 코드 */
export enum ErrorCode {
    /** 타임 아웃 */
    TIMEOUT = -1,
    /** 성공*/
    SUCCESS = 0,
    /** 서버 시스템 에러 */
    SYSTEM_ERROR = 1
}
/** Connect() 결과 코드 */
export enum ResultCodeConnect {
    /** 성공 */
    CONNECT_SUCCESS = 0,
    /** 실패 */
    CONNECT_FAIL = 1
}
/** Authenticate() 결과 코드 */
export enum ResultCodeAuth {
    /** 성공 */
    AUTH_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    AUTH_FAIL_CONTENT = 201,
    /** 실패. 잘못된 어카운트 아이디 */
    AUTH_FAIL_INVALID_ACCOUNT_ID = 202
}
/** GetChannelInfo() 결과 코드 */
export enum ResultCodeChannelInfo {
    /** 성공 */
    CHANNEL_INFO_SUCCESS = 0,
    /** 실패. 체널 정보를 찾을 수 없음 */
    CHANNEL_INFO_FAIL_NO_CHANNEL_INFO = 1901,
    /** 실패. 잘못된 서비스 아이디 */
    CHANNEL_INFO_FAIL_INVALID_SERVICE_ID = 1902,
    /** 실패. 잘못된 채널 아이디 */
    CHANNEL_INFO_FAIL_INVALID_CHANNEL_ID = 1903,
    /** 실패. 채널을 잧을 수 없음 */
    CHANNEL_INFO_FAIL_CHANNEL_NOT_FOUND = 1904
}
/** GetAllChannelInfo() 결과 코드 */
export enum ResultCodeAllChannelInfo {
    /** 성공 */
    ALL_CHANNEL_INFO_SUCCESS = 0,
    /** 실패. 체널 정보를 찾을 수 없음 */
    ALL_CHANNEL_INFO_FAIL_NO_CHANNEL_INFO = 1911,
    /** 실패. 잘못된 서비스 아이디 */
    ALL_CHANNEL_INFO_FAIL_INVALID_SERVICE_ID = 1912,
    /** 실패. 채널을 잧을 수 없음 */
    ALL_CHANNEL_INFO_FAIL_CHANNEL_NOT_FOUND = 1913
}
/** GetChannelCountInfo() 결과 코드 */
export enum ResultCodeChannelCountInfo {
    /** 성공 */
    CHANNEL_COUNT_INFO_SUCCESS = 0,
    /** 실패. 체널 정보를 찾을 수 없음 */
    CHANNEL_COUNT_INFO_FAIL_NO_CHANNEL_INFO = 1921,
    /** 실패. 잘못된 서비스 아이디 */
    CHANNEL_COUNT_INFO_FAIL_INVALID_SERVICE_ID = 1922,
    /** 실패. 잘못된 채널 아이디 */
    CHANNEL_COUNT_INFO_FAIL_INVALID_CHANNEL_ID = 1923,
    /** 실패. 채널을 잧을 수 없음 */
    CHANNEL_COUNT_INFO_FAIL_CHANNEL_NOT_FOUND = 1924
}
/** GetAllChannelCountInfo() 결과 코드 */
export enum ResultCodeAllChannelCountInfo {
    /** 성공 */
    ALL_CHANNEL_COUNT_INFO_SUCCESS = 0,
    /** 실패. 체널 정보를 찾을 수 없음 */
    ALL_CHANNEL_COUNT_INFO_FAIL_NO_CHANNEL_INFO = 1931,
    /** 실패. 체널 정보를 찾을 수 없음 */
    ALL_CHANNEL_COUNT_INFO_FAIL_INVALID_SERVICE_ID = 1932,
    /** 실패. 채널을 잧을 수 없음 */
    ALL_CHANNEL_COUNT_INFO_FAIL_CHANNEL_NOT_FOUND = 1933
}
/** GetChannelList() 결과 코드 */
export enum ResultCodeChannelList {
    /** 성공 */
    CHANNEL_LIST_SUCCESS = 0,
    /** 실패. 체널 목록을 찾을 수 없음 */
    CHANNEL_LIST_FAIL_NO_CHANNEL_LIST = 1801
}
/** CreateRoom() 결과 코드 */
export enum ResultCodeCreateRoom {
    /** 성공 */
    CREATE_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    CREATE_ROOM_FAIL_CONTENT = 601,
    /** 실패. 이미 방에 들어가 있음 */
    CREATE_ROOM_FAIL_ALREADY_JOINED_ROOM = 602,
    /** 실패. 방 아이디 발급 실패 */
    CREATE_ROOM_FAIL_CREATE_ROOM_ID = 603,
    /** 실패. 방 생성 실패 */
    CREATE_ROOM_FAIL_CREATE_ROOM = 604
}
/** JoinRoom() 결과 코드 */
export enum ResultCodeJoinRoom {
    /** 성공 */
    JOIN_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    JOIN_ROOM_FAIL_CONTENT = 701,
    /** 실패. 방이 존재하지 않음 */
    JOIN_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 702,
    /** 실패. 이미 방에 들어가 있음 */
    JOIN_ROOM_FAIL_ALREADY_JOINED_ROOM = 703,
    /** 실패. 이미 룸의 인원수가 차있을 경우 */
    JOIN_ROOM_FAIL_ALREADY_FULL = 704,
    /** 실패. 룸매치에서 문제가 발생할 경우 */
    JOIN_ROOM_FAIL_ROOM_MATCH = 705
}
/** LeaveRoom() 결과 코드 */
export enum ResultCodeLeaveRoom {
    /** 성공 */
    LEAVE_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    LEAVE_ROOM_FAIL_CONTENT = 801
}
/** Login() 결과 코드 */
export enum ResultCodeLogin {
    /** 성공 */
    LOGIN_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    LOGIN_FAIL_CONTENT = 301,
    /** 실패. 노드가 존재하지 않음 */
    LOGIN_FAIL_NOT_EXIST_NODE = 302,
    /** 실패. 게임서버가 응답하지 않음 */
    LOGIN_FAIL_TIMEOUT_GAME_SERVER = 303,
    /** 실패. 잘못된 서비스 아이디 */
    LOGIN_FAIL_INVALID_SERVICEID = 310,
    /** 실패. 잘못된 유저 타입 */
    LOGIN_FAIL_INVALID_USERTYPE = 311,
    /** 실패. 잘못된 유저 아이디 */
    LOGIN_FAIL_INVALID_USERID = 312,
    /** 실패. 잘못된 SubId */
    LOGIN_FAIL_INVALID_SUB_ID = 313,
    /** 실패. 다른 서비스에 로그인 되어있음 */
    LOGIN_FAIL_LOGINED_OTHER_SERVICE = 320,
    /** 실패. 다른 채널에 로그인 되어있음 */
    LOGIN_FAIL_LOGINED_OTHER_CHANNEL = 321,
    /** 실패. 동일 어카운트 아이디로 다른 유저타입이 로그인 되어있음 */
    LOGIN_FAIL_LOGINED_OTHER_USER_TYPE = 322,
    /** 실패. 동일 어카운트 아이디로 다른 디바이스아이디가 로그인 되어있음 */
    LOGIN_FAIL_LOGINED_OTHER_DEVICE = 323
}
/** Logout() 결과 코드 */
export enum ResultCodeLogout {
    /** 성공 */
    LOGOUT_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    LOGOUT_FAIL_CONTENT = 401
}
/** MatchPartyCancel() 결과 코드 */
export enum ResultCodeMatchPartyCancel {
    /** 성공 */
    MATCH_PARTY_CANCEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_PARTY_CANCEL_FAIL_CONTENT = 1401,
    /** 실패. 파티매칭을 취소할 때, 방이 파티매칭용 방이 아닌경우 */
    MATCH_PARTY_CANCEL_FAIL_PARTY_MATCH_WEIRD = 1402
}
/** MatchPartyStart() 결과 코드 */
export enum ResultCodeMatchPartyStart {
    /** 성공 */
    MATCH_PARTY_START_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_PARTY_START_FAIL_CONTENT = 1301,
    /** 실패. 파티매칭을 요청할 때, 방이 파티매칭용 방이 아닌경우 */
    MATCH_PARTY_START_FAIL_PARTY_MATCH_WEIRD = 1302
}
/** MatchUserCancel() 결과 코드 */
export enum ResultCodeMatchUserCancel {
    /** 성공 */
    MATCH_USER_CANCEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_USER_CANCEL_FAIL = 1201,
    /** 실패. 이미 매칭이 이루어짐 */
    MATCH_USER_CANCEL_FAIL_ALREADY_JOINED_ROOM = 1202,
    /** 실패. 매칭이 진행중이지 않은 경우 */
    MATCH_USER_CANCEL_FAIL_NOT_IN_PROGRESS = 1203
}
/** MatchUserStart() 결과 코드 */
export enum ResultCodeMatchUserStart {
    /** 성공 */
    MATCH_USER_START_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_USER_START_FAIL_CONTENT = 1101,
    /** 실패. 이미 방에 들어가 있음 */
    MATCH_USER_START_FAIL_ALREADY_JOINED_ROOM = 1102
}
/** MatchUserDone() 결과 코드 */
export enum ResultCodeMatchUserDone {
    /** 성공 */
    MATCH_USER_DONE_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨(조검에 맞는 방을 찾지 못함) */
    MATCH_USER_DONE_FAIL_CONTENT = 1501,
    /** 실패. 조건에 맞는 방을 찾아 방에 참가 시키는 도중, 방이 사라짐 */
    MATCH_USER_DONE_FAIL_ROOM_DOES_NOT_EXIST = 1502,
    /** 실패. 조건에 맞는 방을 찾아 방에 참가 시키는 도중, 방에 참가하기 위해 트랜스퍼 하는 과정에서 실패함 */
    MATCH_USER_DONE_FAIL_TRANSFER = 1503,
    /** 실패. 방 생성 실패 */
    MATCH_USER_DONE_FAIL_CREATE_ROOM = 1504
}
/** MoveChannel() 결과 코드 */
export enum ResultCodeMoveChannel {
    /** 성공 */
    MOVE_CHANNEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MOVE_CHANNEL_FAIL_CONTENT = 1601,
    /** 실패. 체널 노드를 찾을 수 없음 */
    MOVE_CHANNEL_FAIL_NODE_NOT_FOUND = 1602,
    /** 실패. 이미 요청한 체널에 있음 */
    MOVE_CHANNEL_FAIL_ALREADY_JOINED_CHANNEL = 1603,
    /** 실패. 이미 방에 입장하여 체널 이동을 할 수 없음 */
    MOVE_CHANNEL_FAIL_ALREADY_JOINED_ROOM = 1604
}
/** Snapshot() 결과 코드 */
export enum ResultCodeSnapshot {
    /** 성공 */
    SNAPSHOT_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    SNAPSHOT_FAIL_CONTENT = 501
}
/** MatchRoom() 결과 코드 */
export enum ResultCodeMatchRoom {
    /** 성공 */
    MATCH_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_ROOM_FAIL_CONTENT = 901,
    /** 실패. 방이 존재하지 않음 */
    MATCH_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 902,
    /** 실패. 이미 방에 들어가 있음 */
    MATCH_ROOM_FAIL_ALREADY_JOINED_ROOM = 903,
    /** 실패. 방 이동 기능으로 매칭시킬 때, 기존방에서 나가기가 실패한 경우 */
    MATCH_ROOM_FAIL_LEAVE_ROOM = 904,
    /** 실패. 이미 매치 매이킹이 진행중인 경우 */
    MATCH_ROOM_FAIL_IN_PROGRESS = 905,
    /** 실패. 조건에 맞는 방을 찾아 방에 참가 시키는 도중, 방이 사라짐 */
    MATCH_ROOM_FAIL_MATCHED_ROOM_DOES_NOT_EXIST = 906,
    /** 실패. 방 생성을 위한 방 아이디 발급 실패 */
    MATCH_ROOM_FAIL_CREATE_ROOM_ID = 907,
    /** 실패. 방 생성 실패 */
    MATCH_ROOM_FAIL_CREATE_ROOM = 908,
    /** 실패. 잘못된 룸아이디 */
    MATCH_ROOM_FAIL_INVALID_ROOM_ID = 909,
    /** 실패. 잘못된 노드아이디 */
    MATCH_ROOM_FAIL_INVALID_NODE_ID = 910,
    /** 실패. 잘못된 유저아이디 */
    MATCH_ROOM_FAIL_INVALID_USER_ID = 911,
    /** 실패. 매칭을 진행하였으나, 방을 찾지 못함 */
    MATCH_ROOM_FAIL_MATCHED_ROOM_NOT_FOUND = 912,
    /** 실패. 잘못된 매칭 유저 카테고리 */
    MATCH_ROOM_FAIL_INVALID_MATCHING_USER_CATEGORY = 913,
    /** 실패. 매칭 유저 카테고리 사이즈가 0일 경우 */
    MATCH_ROOM_FAIL_MATCHING_USER_CATEGORY_EMPTY = 914,
    /** 실패. 매칭 신청서가 없음 */
    MATCH_ROOM_FAIL_BASE_ROOM_MATCH_FORM_NULL = 915,
    /** 실패. 매칭 정보가 없음 */
    MATCH_ROOM_FAIL_BASE_ROOM_MATCH_INFO_NULL = 916
}
/** NamedRoom() 결과 코드 */
export enum ResultCodeNamedRoom {
    /** 성공 */
    NAMED_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    NAMED_ROOM_FAIL_CONTENT = 1001,
    /** 실패. 방 생성이 실패하여 방을 찾을 수 없음 */
    NAMED_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 1002,
    /** 실패. 이미 방에 들어가 있음 */
    NAMED_ROOM_FAIL_ALREADY_JOINED_ROOM = 1003,
    /** 실패. 잘못된 방 이름 입력 */
    NAMED_ROOM_FAIL_INVALID_ROOM_NAME = 1004,
    /** 실패. 방 생성 실패 */
    NAMED_ROOM_FAIL_CREATE_ROOM = 1005
}
/** 연결이 해제가 된 이유 */
export enum ResultCodeDisconnect {
    /** 시스템 오류로 인한 강제 종료
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요 */
    FORCE_CLOSE_SYSTEM_ERROR = 2000,
    /** 서버에서 BaseConnection의 close() 호출 */
    FORCE_CLOSE_BASE_CONNECTION = 2010,
    /** 서버에서 BaseUser의 closeConnection() 호출 */
    FORCE_CLOSE_BASE_USER = 2011,
    /** Admin에서 강제 종료 */
    FORCE_CLOSE_ADMIN_KICK = 2012,
    /** GameNode가 invalid 상태로 변경된 경우 */
    FORCE_CLOSE_INVALID_NODE = 2020,
    /** 유저 트렌스퍼가 실패한 경우 */
    FORCE_CLOSE_USER_TRANSFER_FAIL = 2021,
    /** 유저 트렌스퍼중 시스템 에러가 발생한 경우 */
    FORCE_CLOSE_USER_TRANSFER_ERROR = 2022,
    /** 인증 실패로 인한 강제 종료 */
    FORCE_CLOSE_AUTHENTICATION_FAIL = 2030,
    /** 인증 실패로 인한 강제 종료 - 어카운트아이디가 없을 경우 */
    FORCE_CLOSE_AUTHENTICATION_FAIL_EMPTY_ACCOUNT_ID = 2031,
    /** 중복접속으로 인한 강제 종료 */
    FORCE_CLOSE_DUPLICATE_LOGIN = 2032,
    /** 같은 계정 정보로 새로운 로그인 요청이 들어온 경우
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요 */
    FORCE_CLOSE_BY_NEW_CONNECTION = 2040,
    /** 클라이언트와의 연결 끊김을 감지할 경우
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요 */
    FORCE_CLOSE_DISCONNECT_ALARM_FROM_CLIENT = 2041,
    /** 세션 정보를 찾을 수 없는 경우
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요 */
    FORCE_CLOSE_DISCONNECT_ALARM_NOT_FIND_SESSION = 2042,
    /** 클라이언트가 서버의 상태 체크에 응답을 하지 않은 경우
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요*/
    FORCE_CLOSE_CHECK_CLIENT_STATE_FAIL = 2043,
    /** 고스트 유저인 경우
     *
     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 필요*/
    FORCE_CLOSE_GHOST_USER = 2044,
    /** 네트워크 연결이 끊어짐 */
    SOCKET_DISCONNECT = 100,
    /** 소켓 에러가 발생하여 연결을 끊음 */
    SOCKET_ERROR = 101,
    /** 타임아웃이 발생, 컨넥터에서 연결을 끊음 */
    SOCKET_TIME_OUT = 102
}
/** 세션이 닫히게된 이유 */
export enum ResultCodeSessionClose {
    /** 서버에서 BaseUser의 closeConnection() 호출 */
    SESSION_CLOSE_BASE_USER = 2011,
    /** Admin에서 강제 종료 */
    SESSION_CLOSE_ADMIN_KICK = 2012,
    /** 중복접속으로 인한 강제 종료 */
    SESSION_CLOSE_DUPLICATE_LOGIN = 2032,
    /** 같은 계정 정보로 새로운 로그인 요청이 들어온 경우*/
    SESSION_CLOSE_BY_NEW_CONNECTION = 2040,
    /** 세션을 찾을 수 없는 경우*/
    SESSION_CLOSE_DISCONNECT_ALARM_NOT_FIND_SESSION = 2042
}

export interface IMessage {
    className?: string;
    index?: number;
}

export namespace com {

    namespace nhn {

        namespace gameanvilcore {

            namespace protocol {

                enum TargetType {
                    GAME_USER = 0,
                    GATEWAY_CONNECTION = 1,
                    GATEWAY_SESSION = 2
                }

                interface IHeader extends IMessage {
                    errorCode?: (com.nhn.gameanvilcore.protocol.ErrorCode|null);
                    serviceId?: (number|null);
                    subId?: (number|null);
                    targetType?: (com.nhn.gameanvilcore.protocol.TargetType|null);
                    msgId?: (number|null);
                    seq?: (number|null);
                    uncompressSize?: (number|null);
                }

                class Header implements IHeader {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IHeader);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public errorCode: com.nhn.gameanvilcore.protocol.ErrorCode;
                    public serviceId: number;
                    public subId: number;
                    public targetType: com.nhn.gameanvilcore.protocol.TargetType;
                    public msgId: number;
                    public seq: number;
                    public uncompressSize: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IHeader): com.nhn.gameanvilcore.protocol.Header;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Header, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Header;
                }

                interface IPayload extends IMessage {
                    msgId?: (number|null);
                    data?: (Uint8Array|null);
                    priority?: (number|null);
                }

                class Payload implements IPayload {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPayload);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public msgId: number;
                    public data: Uint8Array;
                    public priority: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPayload): com.nhn.gameanvilcore.protocol.Payload;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Payload, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Payload;
                }

                interface IMultiMessage extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    reply?: (com.nhn.gameanvilcore.protocol.Payload|null);
                }

                class MultiMessage implements IMultiMessage {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMultiMessage);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public reply?: (com.nhn.gameanvilcore.protocol.Payload|null);
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMultiMessage): com.nhn.gameanvilcore.protocol.MultiMessage;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MultiMessage, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MultiMessage;
                }

                interface IPing extends IMessage {
                }

                class Ping implements IPing {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPing);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPing): com.nhn.gameanvilcore.protocol.Ping;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Ping, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Ping;
                }

                interface IPong extends IMessage {
                }

                class Pong implements IPong {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPong);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPong): com.nhn.gameanvilcore.protocol.Pong;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Pong, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Pong;
                }

                interface IClientStateCheck extends IMessage {
                }

                class ClientStateCheck implements IClientStateCheck {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IClientStateCheck);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IClientStateCheck): com.nhn.gameanvilcore.protocol.ClientStateCheck;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ClientStateCheck, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ClientStateCheck;
                }

                interface IClientStateOK extends IMessage {
                }

                class ClientStateOK implements IClientStateOK {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IClientStateOK);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IClientStateOK): com.nhn.gameanvilcore.protocol.ClientStateOK;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ClientStateOK, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ClientStateOK;
                }

                interface IAuthenticationReq extends IMessage {
                    accountId?: (string|null);
                    password?: (string|null);
                    deviceId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class AuthenticationReq implements IAuthenticationReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public accountId: string;
                    public password: string;
                    public deviceId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationReq): com.nhn.gameanvilcore.protocol.AuthenticationReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AuthenticationReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AuthenticationReq;
                }

                interface IAuthenticationRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    userList?: (com.nhn.gameanvilcore.protocol.LoginedUserInfo[]|null);
                    message?: (string|null);
                    serviceIds?: ({ [k: string]: number }|null);
                }

                class AuthenticationRes implements IAuthenticationRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public userList: com.nhn.gameanvilcore.protocol.LoginedUserInfo[];
                    public message: string;
                    public serviceIds: { [k: string]: number };
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationRes): com.nhn.gameanvilcore.protocol.AuthenticationRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AuthenticationRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AuthenticationRes;
                }

                interface ILoginReq extends IMessage {
                    subId?: (number|null);
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    userType?: (string|null);
                }

                class LoginReq implements ILoginReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public userType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginReq): com.nhn.gameanvilcore.protocol.LoginReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginReq;
                }

                interface ILoginRes extends IMessage {
                    userId?: (number|null);
                    userType?: (string|null);
                    channelId?: (string|null);
                    serviceId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    message?: (string|null);
                    isUserMatching?: (boolean|null);
                    isRelogined?: (boolean|null);
                    rejoinedRoomId?: (number|null);
                    rejoinedRoomName?: (string|null);
                    roomRejoinPayload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LoginRes implements ILoginRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public userId: number;
                    public userType: string;
                    public channelId: string;
                    public serviceId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public message: string;
                    public isUserMatching: boolean;
                    public isRelogined: boolean;
                    public rejoinedRoomId: number;
                    public rejoinedRoomName: string;
                    public roomRejoinPayload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginRes): com.nhn.gameanvilcore.protocol.LoginRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginRes;
                }

                interface ILoginedUserInfo extends IMessage {
                    subId?: (number|null);
                    serviceId?: (number|null);
                    userId?: (number|null);
                    userType?: (string|null);
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LoginedUserInfo implements ILoginedUserInfo {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginedUserInfo);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public serviceId: number;
                    public userId: number;
                    public userType: string;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginedUserInfo): com.nhn.gameanvilcore.protocol.LoginedUserInfo;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginedUserInfo, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginedUserInfo;
                }

                interface ILogoutReq extends IMessage {
                    subId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LogoutReq implements ILogoutReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILogoutReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILogoutReq): com.nhn.gameanvilcore.protocol.LogoutReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LogoutReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LogoutReq;
                }

                interface ILogoutRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LogoutRes implements ILogoutRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILogoutRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILogoutRes): com.nhn.gameanvilcore.protocol.LogoutRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LogoutRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LogoutRes;
                }

                interface ISnapshotReq extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class SnapshotReq implements ISnapshotReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ISnapshotReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ISnapshotReq): com.nhn.gameanvilcore.protocol.SnapshotReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.SnapshotReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.SnapshotReq;
                }

                interface ISnapshotRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class SnapshotRes implements ISnapshotRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ISnapshotRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ISnapshotRes): com.nhn.gameanvilcore.protocol.SnapshotRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.SnapshotRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.SnapshotRes;
                }

                interface ICreateRoomReq extends IMessage {
                    roomType?: (string|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class CreateRoomReq implements ICreateRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomReq): com.nhn.gameanvilcore.protocol.CreateRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.CreateRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.CreateRoomReq;
                }

                interface ICreateRoomRes extends IMessage {
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class CreateRoomRes implements ICreateRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomRes): com.nhn.gameanvilcore.protocol.CreateRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.CreateRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.CreateRoomRes;
                }

                interface IJoinRoomReq extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                }

                class JoinRoomReq implements IJoinRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomReq): com.nhn.gameanvilcore.protocol.JoinRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.JoinRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.JoinRoomReq;
                }

                interface IJoinRoomRes extends IMessage {
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class JoinRoomRes implements IJoinRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomRes): com.nhn.gameanvilcore.protocol.JoinRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.JoinRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.JoinRoomRes;
                }

                interface ILeaveRoomReq extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LeaveRoomReq implements ILeaveRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomReq): com.nhn.gameanvilcore.protocol.LeaveRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LeaveRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LeaveRoomReq;
                }

                interface ILeaveRoomRes extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LeaveRoomRes implements ILeaveRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomRes): com.nhn.gameanvilcore.protocol.LeaveRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LeaveRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LeaveRoomRes;
                }

                interface IMatchRoomReq extends IMessage {
                    roomId?: (number|null);
                    create?: (boolean|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                    moveRoom?: (boolean|null);
                    leaveRoomPayload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    matchingGroup?: (string|null);
                }

                class MatchRoomReq implements IMatchRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public create: boolean;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public moveRoom: boolean;
                    public leaveRoomPayload: com.nhn.gameanvilcore.protocol.Payload[];
                    public matchingGroup: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomReq): com.nhn.gameanvilcore.protocol.MatchRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchRoomReq;
                }

                interface IMatchRoomRes extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchRoomRes implements IMatchRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomRes): com.nhn.gameanvilcore.protocol.MatchRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchRoomRes;
                }

                interface INamedRoomReq extends IMessage {
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                    party?: (boolean|null);
                }

                class NamedRoomReq implements INamedRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INamedRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public party: boolean;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INamedRoomReq): com.nhn.gameanvilcore.protocol.NamedRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.NamedRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.NamedRoomReq;
                }

                interface INamedRoomRes extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class NamedRoomRes implements INamedRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INamedRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INamedRoomRes): com.nhn.gameanvilcore.protocol.NamedRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.NamedRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.NamedRoomRes;
                }

                interface IMatchUserStartReq extends IMessage {
                    roomType?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserStartReq implements IMatchUserStartReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartReq): com.nhn.gameanvilcore.protocol.MatchUserStartReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserStartReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserStartReq;
                }

                interface IMatchUserStartRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserStartRes implements IMatchUserStartRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartRes): com.nhn.gameanvilcore.protocol.MatchUserStartRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserStartRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserStartRes;
                }

                interface IMatchPartyStartReq extends IMessage {
                    roomType?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchPartyStartReq implements IMatchPartyStartReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartReq): com.nhn.gameanvilcore.protocol.MatchPartyStartReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyStartReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyStartReq;
                }

                interface IMatchPartyStartResOrNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchPartyStartResOrNoti implements IMatchPartyStartResOrNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartResOrNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartResOrNoti): com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti;
                }

                interface IMatchPartyCancelReq extends IMessage {
                    roomType?: (string|null);
                }

                class MatchPartyCancelReq implements IMatchPartyCancelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelReq): com.nhn.gameanvilcore.protocol.MatchPartyCancelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyCancelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyCancelReq;
                }

                interface IMatchPartyCancelResOrNoti extends IMessage {
                }

                class MatchPartyCancelResOrNoti implements IMatchPartyCancelResOrNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelResOrNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelResOrNoti): com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti;
                }

                interface IMatchUserDone extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserDone implements IMatchUserDone {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserDone);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserDone): com.nhn.gameanvilcore.protocol.MatchUserDone;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserDone, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserDone;
                }

                interface IMatchUserTimeout extends IMessage {
                }

                class MatchUserTimeout implements IMatchUserTimeout {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserTimeout);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserTimeout): com.nhn.gameanvilcore.protocol.MatchUserTimeout;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserTimeout, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserTimeout;
                }

                interface IMatchUserCancelReq extends IMessage {
                    roomType?: (string|null);
                }

                class MatchUserCancelReq implements IMatchUserCancelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelReq): com.nhn.gameanvilcore.protocol.MatchUserCancelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserCancelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserCancelReq;
                }

                interface IMatchUserCancelRes extends IMessage {
                }

                class MatchUserCancelRes implements IMatchUserCancelRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelRes): com.nhn.gameanvilcore.protocol.MatchUserCancelRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserCancelRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserCancelRes;
                }

                interface IMoveChannelReq extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelReq implements IMoveChannelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelReq): com.nhn.gameanvilcore.protocol.MoveChannelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelReq;
                }

                interface IMoveChannelRes extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelRes implements IMoveChannelRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelRes): com.nhn.gameanvilcore.protocol.MoveChannelRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelRes;
                }

                interface IGetChannelListReq extends IMessage {
                    serviceId?: (number|null);
                }

                class GetChannelListReq implements IGetChannelListReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListReq): com.nhn.gameanvilcore.protocol.GetChannelListReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelListReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelListReq;
                }

                interface IGetChannelListRes extends IMessage {
                    channelList?: (string[]|null);
                }

                class GetChannelListRes implements IGetChannelListRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelList: string[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListRes): com.nhn.gameanvilcore.protocol.GetChannelListRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelListRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelListRes;
                }

                interface IChannelInfo extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ChannelInfo implements IChannelInfo {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IChannelInfo);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IChannelInfo): com.nhn.gameanvilcore.protocol.ChannelInfo;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ChannelInfo, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ChannelInfo;
                }

                interface IGetChannelInfoReq extends IMessage {
                    serviceId?: (number|null);
                    channelId?: (string|null);
                }

                class GetChannelInfoReq implements IGetChannelInfoReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public channelId: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoReq): com.nhn.gameanvilcore.protocol.GetChannelInfoReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelInfoReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelInfoReq;
                }

                interface IGetChannelInfoRes extends IMessage {
                    channelInfo?: (com.nhn.gameanvilcore.protocol.ChannelInfo|null);
                }

                class GetChannelInfoRes implements IGetChannelInfoRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelInfo?: (com.nhn.gameanvilcore.protocol.ChannelInfo|null);
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoRes): com.nhn.gameanvilcore.protocol.GetChannelInfoRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelInfoRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelInfoRes;
                }

                interface IGetAllChannelInfoReq extends IMessage {
                    serviceId?: (number|null);
                }

                class GetAllChannelInfoReq implements IGetAllChannelInfoReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelInfoReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelInfoReq): com.nhn.gameanvilcore.protocol.GetAllChannelInfoReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetAllChannelInfoReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetAllChannelInfoReq;
                }

                interface IGetAllChannelInfoRes extends IMessage {
                    channelInfo?: ({ [k: string]: com.nhn.gameanvilcore.protocol.ChannelInfo }|null);
                }

                class GetAllChannelInfoRes implements IGetAllChannelInfoRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelInfoRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelInfo: { [k: string]: com.nhn.gameanvilcore.protocol.ChannelInfo };
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelInfoRes): com.nhn.gameanvilcore.protocol.GetAllChannelInfoRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetAllChannelInfoRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetAllChannelInfoRes;
                }

                interface IChannelCountInfo extends IMessage {
                    channelId?: (string|null);
                    userCount?: (number|null);
                    roomCount?: (number|null);
                }

                class ChannelCountInfo implements IChannelCountInfo {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IChannelCountInfo);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public userCount: number;
                    public roomCount: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IChannelCountInfo): com.nhn.gameanvilcore.protocol.ChannelCountInfo;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ChannelCountInfo, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ChannelCountInfo;
                }

                interface IGetChannelCountInfoReq extends IMessage {
                    serviceId?: (number|null);
                    channelId?: (string|null);
                }

                class GetChannelCountInfoReq implements IGetChannelCountInfoReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelCountInfoReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public channelId: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelCountInfoReq): com.nhn.gameanvilcore.protocol.GetChannelCountInfoReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelCountInfoReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelCountInfoReq;
                }

                interface IGetChannelCountInfoRes extends IMessage {
                    channelCountInfo?: (com.nhn.gameanvilcore.protocol.ChannelCountInfo|null);
                }

                class GetChannelCountInfoRes implements IGetChannelCountInfoRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelCountInfoRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelCountInfo?: (com.nhn.gameanvilcore.protocol.ChannelCountInfo|null);
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelCountInfoRes): com.nhn.gameanvilcore.protocol.GetChannelCountInfoRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelCountInfoRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelCountInfoRes;
                }

                interface IGetAllChannelCountInfoReq extends IMessage {
                    serviceId?: (number|null);
                }

                class GetAllChannelCountInfoReq implements IGetAllChannelCountInfoReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelCountInfoReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelCountInfoReq): com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoReq;
                }

                interface IGetAllChannelCountInfoRes extends IMessage {
                    channelCountInfo?: ({ [k: string]: com.nhn.gameanvilcore.protocol.ChannelCountInfo }|null);
                }

                class GetAllChannelCountInfoRes implements IGetAllChannelCountInfoRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelCountInfoRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelCountInfo: { [k: string]: com.nhn.gameanvilcore.protocol.ChannelCountInfo };
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetAllChannelCountInfoRes): com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetAllChannelCountInfoRes;
                }

                interface IForceLogoutNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceLogoutNoti implements IForceLogoutNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceLogoutNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceLogoutNoti): com.nhn.gameanvilcore.protocol.ForceLogoutNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceLogoutNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceLogoutNoti;
                }

                interface IForceCloseConnectionNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceCloseConnectionNoti implements IForceCloseConnectionNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceCloseConnectionNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceCloseConnectionNoti): com.nhn.gameanvilcore.protocol.ForceCloseConnectionNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceCloseConnectionNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceCloseConnectionNoti;
                }

                interface IForceCloseSessionNoti extends IMessage {
                    serviceId?: (number|null);
                    subId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceCloseSessionNoti implements IForceCloseSessionNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceCloseSessionNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public subId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceCloseSessionNoti): com.nhn.gameanvilcore.protocol.ForceCloseSessionNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceCloseSessionNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceCloseSessionNoti;
                }

                interface IForceLeaveRoomNoti extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceLeaveRoomNoti implements IForceLeaveRoomNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceLeaveRoomNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceLeaveRoomNoti): com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti;
                }

                interface IMoveChannelNoti extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelNoti implements IMoveChannelNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelNoti): com.nhn.gameanvilcore.protocol.MoveChannelNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelNoti;
                }

                interface INotice extends IMessage {
                    message?: (string|null);
                }

                class Notice implements INotice {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INotice);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public message: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INotice): com.nhn.gameanvilcore.protocol.Notice;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Notice, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Notice;
                }

                interface IAdminKickoutNoti extends IMessage {
                    message?: (string|null);
                }

                class AdminKickoutNoti implements IAdminKickoutNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAdminKickoutNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public message: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAdminKickoutNoti): com.nhn.gameanvilcore.protocol.AdminKickoutNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AdminKickoutNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AdminKickoutNoti;
                }

                interface IPauseClientStateCheck extends IMessage {
                    pauseTime?: (number|null);
                }

                class PauseClientStateCheck implements IPauseClientStateCheck {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPauseClientStateCheck);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public pauseTime: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPauseClientStateCheck): com.nhn.gameanvilcore.protocol.PauseClientStateCheck;
                    public static encode(message: com.nhn.gameanvilcore.protocol.PauseClientStateCheck, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.PauseClientStateCheck;
                }

                interface IResumeClientStateCheck extends IMessage {
                }

                class ResumeClientStateCheck implements IResumeClientStateCheck {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IResumeClientStateCheck);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IResumeClientStateCheck): com.nhn.gameanvilcore.protocol.ResumeClientStateCheck;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ResumeClientStateCheck, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ResumeClientStateCheck;
                }

                enum ErrorCode {
                    SUCCESS = 0,
                    SYSTEM_ERROR = 1,
                    REQ_TIME_OUT = 10,
                    AUTH_SUCCESS = 0,
                    AUTH_FAIL_CONTENT = 201,
                    AUTH_FAIL_MAINTENANCE = 202,
                    AUTH_FAIL_INVALID_ACCOUNT_ID = 203,
                    LOGIN_SUCCESS = 0,
                    LOGIN_FAIL_CONTENT = 301,
                    LOGIN_FAIL_NOT_EXIST_NODE = 302,
                    LOGIN_FAIL_MAINTENANCE = 303,
                    LOGIN_FAIL_TIMEOUT_GAME_SERVER = 304,
                    LOGIN_FAIL_INVALID_SERVICEID = 310,
                    LOGIN_FAIL_INVALID_USERTYPE = 311,
                    LOGIN_FAIL_INVALID_USER_ID = 312,
                    LOGIN_FAIL_INVALID_SUB_ID = 313,
                    LOGIN_FAIL_LOGINED_OTHER_SERVICE = 320,
                    LOGIN_FAIL_LOGINED_OTHER_CHANNEL = 321,
                    LOGIN_FAIL_LOGINED_OTHER_USER_TYPE = 322,
                    LOGIN_FAIL_LOGINED_OTHER_DEVICE = 323,
                    LOGOUT_SUCCESS = 0,
                    LOGOUT_FAIL_CONTENT = 401,
                    SNAPSHOT_SUCCESS = 0,
                    SNAPSHOT_FAIL_CONTENT = 501,
                    CREATE_ROOM_SUCCESS = 0,
                    CREATE_ROOM_FAIL_CONTENT = 601,
                    CREATE_ROOM_FAIL_ALREADY_JOINED_ROOM = 602,
                    CREATE_ROOM_FAIL_CREATE_ROOM_ID = 603,
                    CREATE_ROOM_FAIL_CREATE_ROOM = 604,
                    JOIN_ROOM_SUCCESS = 0,
                    JOIN_ROOM_FAIL_CONTENT = 701,
                    JOIN_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 702,
                    JOIN_ROOM_FAIL_ALREADY_JOINED_ROOM = 703,
                    JOIN_ROOM_FAIL_ALREADY_FULL = 704,
                    JOIN_ROOM_FAIL_ROOM_MATCH = 705,
                    LEAVE_ROOM_SUCCESS = 0,
                    LEAVE_ROOM_FAIL_CONTENT = 801,
                    MATCH_ROOM_SUCCESS = 0,
                    MATCH_ROOM_FAIL_CONTENT = 901,
                    MATCH_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 902,
                    MATCH_ROOM_FAIL_ALREADY_JOINED_ROOM = 903,
                    MATCH_ROOM_FAIL_LEAVE_ROOM = 904,
                    MATCH_ROOM_FAIL_IN_PROGRESS = 905,
                    MATCH_ROOM_FAIL_MATCHED_ROOM_DOES_NOT_EXIST = 906,
                    MATCH_ROOM_FAIL_CREATE_ROOM_ID = 907,
                    MATCH_ROOM_FAIL_CREATE_ROOM = 908,
                    MATCH_ROOM_FAIL_INVALID_ROOM_ID = 909,
                    MATCH_ROOM_FAIL_INVALID_NODE_ID = 910,
                    MATCH_ROOM_FAIL_INVALID_USER_ID = 911,
                    MATCH_ROOM_FAIL_MATCHED_ROOM_NOT_FOUND = 912,
                    MATCH_ROOM_FAIL_INVALID_MATCHING_USER_CATEGORY = 913,
                    MATCH_ROOM_FAIL_MATCHING_USER_CATEGORY_EMPTY = 914,
                    MATCH_ROOM_FAIL_BASE_ROOM_MATCH_FORM_NULL = 915,
                    MATCH_ROOM_FAIL_BASE_ROOM_MATCH_INFO_NULL = 916,
                    MATCH_ROOM_FAIL_ALREADY_REGISTER_ROOM = 917,
                    NAMED_ROOM_SUCCESS = 0,
                    NAMED_ROOM_FAIL_CONTENT = 1001,
                    NAMED_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 1002,
                    NAMED_ROOM_FAIL_ALREADY_JOINED_ROOM = 1003,
                    NAMED_ROOM_FAIL_INVALID_ROOM_NAME = 1004,
                    NAMED_ROOM_FAIL_CREATE_ROOM = 1005,
                    MATCH_USER_START_SUCCESS = 0,
                    MATCH_USER_START_FAIL_CONTENT = 1101,
                    MATCH_USER_START_FAIL_ALREADY_JOINED_ROOM = 1102,
                    MATCH_USER_CANCEL_SUCCESS = 0,
                    MATCH_USER_CANCEL_FAIL = 1201,
                    MATCH_USER_CANCEL_FAIL_ALREADY_JOINED_ROOM = 1202,
                    MATCH_USER_CANCEL_FAIL_NOT_IN_PROGRESS = 1203,
                    MATCH_PARTY_START_SUCCESS = 0,
                    MATCH_PARTY_START_FAIL_CONTENT = 1301,
                    MATCH_PARTY_START_FAIL_PARTY_MATCH_WEIRD = 1302,
                    MATCH_PARTY_CANCEL_SUCCESS = 0,
                    MATCH_PARTY_CANCEL_FAIL_CONTENT = 1401,
                    MATCH_PARTY_CANCEL_FAIL_PARTY_MATCH_WEIRD = 1402,
                    MATCH_USER_DONE_SUCCESS = 0,
                    MATCH_USER_DONE_FAIL_CONTENT = 1501,
                    MATCH_USER_DONE_FAIL_ROOM_DOES_NOT_EXIST = 1502,
                    MATCH_USER_DONE_FAIL_TRANSFER = 1503,
                    MATCH_USER_DONE_FAIL_CREATE_ROOM = 1504,
                    MOVE_CHANNEL_SUCCESS = 0,
                    MOVE_CHANNEL_FAIL_CONTENT = 1601,
                    MOVE_CHANNEL_FAIL_NODE_NOT_FOUND = 1602,
                    MOVE_CHANNEL_FAIL_ALREADY_JOINED_CHANNEL = 1603,
                    MOVE_CHANNEL_FAIL_ALREADY_JOINED_ROOM = 1604,
                    CHANNEL_LIST_SUCCESS = 0,
                    CHANNEL_LIST_FAIL_NO_CHANNEL_LIST = 1801,
                    CHANNEL_INFO_SUCCESS = 0,
                    CHANNEL_INFO_FAIL_NO_CHANNEL_INFO = 1901,
                    CHANNEL_INFO_FAIL_INVALID_SERVICE_ID = 1902,
                    CHANNEL_INFO_FAIL_INVALID_CHANNEL_ID = 1903,
                    CHANNEL_INFO_FAIL_CHANNEL_NOT_FOUND = 1904,
                    ALL_CHANNEL_INFO_SUCCESS = 0,
                    ALL_CHANNEL_INFO_FAIL_NO_CHANNEL_INFO = 1911,
                    ALL_CHANNEL_INFO_FAIL_INVALID_SERVICE_ID = 1912,
                    ALL_CHANNEL_INFO_FAIL_CHANNEL_NOT_FOUND = 1913,
                    CHANNEL_COUNT_INFO_SUCCESS = 0,
                    CHANNEL_COUNT_INFO_FAIL_NO_CHANNEL_INFO = 1921,
                    CHANNEL_COUNT_INFO_FAIL_INVALID_SERVICE_ID = 1922,
                    CHANNEL_COUNT_INFO_FAIL_INVALID_CHANNEL_ID = 1923,
                    CHANNEL_COUNT_INFO_FAIL_CHANNEL_NOT_FOUND = 1924,
                    ALL_CHANNEL_COUNT_INFO_SUCCESS = 0,
                    ALL_CHANNEL_COUNT_INFO_FAIL_NO_CHANNEL_INFO = 1931,
                    ALL_CHANNEL_COUNT_INFO_FAIL_INVALID_SERVICE_ID = 1932,
                    ALL_CHANNEL_COUNT_INFO_FAIL_CHANNEL_NOT_FOUND = 1933,
                    FORCE_CLOSE_SYSTEM_ERROR = 2000,
                    FORCE_CLOSE_BASE_CONNECTION = 2010,
                    FORCE_CLOSE_BASE_USER = 2011,
                    FORCE_CLOSE_ADMIN_KICK = 2012,
                    FORCE_CLOSE_MAINTENANCE = 2020,
                    FORCE_CLOSE_INVALID_NODE = 2021,
                    FORCE_CLOSE_USER_TRANSFER_FAIL = 2022,
                    FORCE_CLOSE_USER_TRANSFER_ERROR = 2023,
                    FORCE_CLOSE_AUTHENTICATION_FAIL = 2030,
                    FORCE_CLOSE_AUTHENTICATION_FAIL_EMPTY_ACCOUNT_ID = 2031,
                    FORCE_CLOSE_DUPLICATE_LOGIN = 2032,
                    FORCE_CLOSE_BY_NEW_CONNECTION = 2040,
                    FORCE_CLOSE_DISCONNECT_ALARM_FROM_CLIENT = 2041,
                    FORCE_CLOSE_DISCONNECT_ALARM_NOT_FIND_SESSION = 2042,
                    FORCE_CLOSE_CHECK_CLIENT_STATE_FAIL = 2043,
                    FORCE_CLOSE_GHOST_USER = 2044,
                    SOCKET_DISCONNECT = 2100,
                    SOCKET_TIME_OUT = 2101,
                    SOCKET_ERROR = 2102
                }
            }
        }
    }
}
import Base = com.nhn.gameanvilcore.protocol;
export { Base }

/**
 * Object을 Uint8Array로 변환해주거나 Uint8Array를 Object로 변환해주는 유틸리티 클래스
 */
export class JsonUtil {
    /**
     * Uint8Array을 Object로 변환
     * @typeparam Object의 타입
     * @param buffer 변환하고자 하는 Uint8Array
     */
    static Deserialize<T>(buffer: Uint8Array): T;
    /**
     * Object를 Uint8Array로 변환
     * @param object 변환하고자 하는 Object
     */
    static Serialize(object: any): Uint8Array;
}

/**
 * 서버와 주고 받는 모든 메세지는 패킷에 실려서 처리 되며 패킷이 제공하는 인터페이스를 이용
 */
export class Packet {
    /**
     * 패킷간의 우선순위를 비교
     * @param ap 비교할 패킷 A
     * @param bp 비교할 패킷 B
     * @return 우선 순위가 낮으면 -1, 같으면 0, 크면 1
     */
    static CompareTo(ap: Packet, bp: Packet): number;
    /**
     * 패킷을 복사
     * @return 복사한 새 패킷
     */
    Clone(): Packet;
    /**
     * 입력받은 메세지를 담은 패킷을 생성
     * @param msg 생성할 메세지
     * @returns 생성한 패킷
     */
    static CreateFromPbMsg(msg: IMessage): Packet;
    /**
     * 메세지 아이디와 Uint8Array를 이용해 패킷을 생성
     * @param msgIndex 패킷을 구분하기위한 아이디. 서버와 약속된 값
     * @param buffer 패킷에 담을 Uint8Array
     * @returns 생성한 패킷
     */
    static CreateFromBuffer(msgIndex: number, buffer: Uint8Array): Packet;
    /**
     * 메세지 아이디와 Object를 이용해 패킷을 생성
     *
     * 입력된 Object를 JSON스트링으로 변환하여 패킷저장
     * @param msgIndex 패킷을 구분하기위한 아이디. 서버와 약속된 값
     * @param obj JSON스트링으로 변환할 임의의 Object
     * @returns 생성한 패킷
     */
    static CreateFromObject(msgIndex: number, obj: any): Packet;
    /**
     * 패킷에 저장됭 메세지를 반환
     * @typeparam 프로토 버프 타입 메세지
     * @returns 메세지. 패킷에 저장된 메세지가 없을경우 널
     */
    GetPbMessage<T extends IMessage>(): T;
    /**
     * 패킷에 담인 값을 Object로 변환해 반환
     * @returns Object. 메세지 아이디를 가진 패킷이 아닌경우 널
     */
    GetObject(): any;
    /**
     * 패킷의 우선순위 반환
     */
    GetPriority(): number;
    /**
     * 패킷의 우선순위를 설정
     * @param value 우선순위
     */
    SetPriority(value: number): void;
    /**
     * 패킷의 압축 여부를 반환
     */
    IsCompress(): boolean;
    /**
     * 패킷에 저장된 Uint8Array 반환
     */
    GetBytes(): Uint8Array;
    /**
     * 압축을 해제했을 경우 크기를 반환
     *
     * 압축하지 않았을 경우 0
     * @returns 압축된 크기
     */
    GetUnCompressSize(): number;
    /**
     * 패킷을 압축
     * @returns 압축된 패킷
     */
    Compress(): Packet;
    /**
     * 패킷의 압축을 해제
     * @returns 압축 해제된 패킷
     */
    Decompress(): Packet;
}

/**
 * 커넥터에서 사용할 프로토콜을 관리
 *
 * 프로토버프를 지원하며 서버와 주고받는 모든 프로토콜은 미리 등록 필요
 */
export class ProtocolManager {
    /**
     * 사용할 프로토콜을 등록
     * @param protocolId 등록할 프로토콜의 아이디. 서버와 같은 값을 사용 ( protocolId >= 0 && protocolId <= 510 )
     * @param protocol 등록할 프로토콜. 개별 메세지가 아닌 모든 메세지를 가진 상위 객체를 등록
     */
    static RegisterProtocol(protocolId: number, protocol: any): void;
    /**
     * 등록한 프로토콜을 등록 해제
     * @param protocolId 등록 해제할 프로토콜의 아이디
     */
    static UnregisterProtocol(protocolId: number): void;
    /**
     * 메세지의 프로토콜 아이디를 반환
     * @param msg 확인하고자 하는 메세지
     */
    static GetProtocolId<T extends IMessage>(msg: IMessage | (new () => T)): number;
    /**
     * 패킷에 저장된 메세지를 반환
     *
     * 등록하지 않은 메세지인 경우 널을 반환
     * @param target 메세지가 저장된 패킷
     * @returns 패킷에 저장된 메세지
     */
    static GetMessage(target: Packet): IMessage;
    /**
     * 패킷에 저장된 메세지의 이름을 반환
     *
     * 등록하지 않은 메세지인 경우 빈 문자열을 반환
     * @param target 메세지가 저장된 패킷
     * @returns 메세지의 이름
     */
    static GetMessageName(target: Packet): string;
    /**
     * 입력받은 메세지가 패킷에에 저장된 메세지와 같은 종류인지 비교
     * @param msg 비교할 메세지
     * @param target 비교할 패킷
     * @returns 같은 경우 true, 아닐경우 false
     */
    static IsProtocol(msg: IMessage, target: Packet): boolean;
}


/**
 * 여러개의 패킷을 담기 위한 클래스
 */
export class Payload {
    /**
     * 페이로드에 패킷을 추가
     * @param packet 추가할 패킷
     */
    Add(packet: Packet): void;
    /**
     * 패킷 목록을 추가
     * @param packetList 추가할 패킷 목록
     */
    AddAll(packetList: Array<Packet>): void;
    /**
     * 저장된 패킷중 메세지 아이디에 해당 하는 패킷 하나를 반환
     * @param msgIndex 찾을 패킷의 메세지 아이디
     * @returns 메세지 아이디를 가진 패킷. 없을 경우 undefined
     */
    GetPacket(msgIndex: number): Packet;
    /**
     * 저장된 패킷중 전달받은 메세지 패킷 반환
     * @param msg 찾을 패킷의 메세지
     * @returns 메세지를 가진 패킷. 없을 경우 undefined
     */
    GetPacket<T extends IMessage>(msg: new () => T): Packet;
    /**
     * 저장된 패킷중 원하는 패킷이 있는지 확인
     * @param msgIndex 확인할 패킷의 메세지 아이디
     * @returns 있을 경우 true. 없을 false
     */
    Contains(msgIndex: number): boolean;
    /**
     * 저장된 패킷중 원하는 패킷이 있는지 확인
     * @param msg 확인할 패킷의 메세지
     * @returns 있을 경우 true. 없을 false
     */
    Contains<T extends IMessage>(msg: new () => T): boolean;
    /**
     * 저장된 패킷중에서 해당 메세지를 반환
     * @param msg IMessage 형태의 메세지
     */
    GetPBMessage<T extends IMessage>(msg: new () => T): T;
    /**
     * 저장된 패킷중에서 해당 메세지 아이디의 Object를 반환
     * @param msgIndex Object가 저장된 패킷의 메세지 아아디
     */
    GetObject(msgIndex: number): any;
    /**
     * 빈 페이로드를 생성
     * @returns 생성한 페이로드
     */
    static CreateEmpty(): Payload;
    /**
     * 메세지를 담은 패킷 한개를 추가한 페이로드를 생성
     * @returns 생성한 페이로드
     */
    static CreateFromPbMSg(msg: IMessage): Payload;
    /**
     * 메세지 아이디와 Uint8Array를 담은 패킷 한개를 추가한 페이로드를 생성
     * @returns 생성한 페이로드
     */
    static CreateFromBuffer(msgIndex: number, buffer: Uint8Array): Payload;
    /**
     * 메세지 아이디와 Object를 담은 패킷 한개를 추가한 페이로드를 생성
     * @returns 생성한 페이로드
     */
    static CreateFromObject(msgIndex: number, obj: any): Payload;
}

/**
 * 내부용 이므로 사용하면 안된다.
 */
export class InternalPacket {
    static CompareTo(a: InternalPacket, b: InternalPacket): number;
    static CreateFromPayload(payload: Base.Payload): InternalPacket;
    static CreateFromPayloads(payloads: Array<Base.Payload>): Array<InternalPacket>;
    static CreateFromPackets(packets: Array<Packet>): InternalPacket;
    static CreateFromPbMsg(msg: IMessage): InternalPacket;
    static CreateFromPacket(packet: Packet): InternalPacket;
    Clone(): InternalPacket;
    SetServiceId(value: number): void;
    GetServiceId(): number;
    GetSubId(): number;
    SetSubId(value: number): void;
    GetMsgId(): number;
    GetBytes(): Uint8Array;
    GetPacket(): Packet;
    SetSeq(value: number): void;
    GetSeq(): number;
    IsMultiMessage(): boolean;
}

/**
 * 내부용 이므로 사용하면 안된다.
 */
export class ResultCodeUtil {
    static toResultCode<E>(errorCode: Base.ErrorCode): E;
    static toErrorCode(resultCode: any): Base.ErrorCode;
}

export interface AllChannelInfo {
    [key: string]: Payload;
}
export interface AllChannelCountInfo {
    [key: string]: ChannelCountInfo;
}
export class ChannelCountInfo {
    private channelId;
    private userCount;
    private roomCount;
    private constructor();
    GetChannelId(): string;
    GetUserCount(): number;
    GetRoomCount(): number;
    static CreateChannelCountInfo(channelCountInfo: Base.ChannelCountInfo): any;
    static CreateChannelCountInfo(channelId: string, userCount: number, roomCount: number): any;
}

/**
 * 내부용 이므로 사용하면 안된다.
*/
export class EventCallback {
    constructor(isVolatile: boolean);
    Clear(): void;
    Add(cmdName: string, callback: any): void;
    Remove(cmdName: string, callback?: any): void;
    Has(cmdName: string): boolean;
    Contains(cmdName: string, callback: any): boolean;
    Call(cmdName: string, arg1: any, arg2?: any, arg3?: any, arg4?: any, arg5?: any, arg6?: any, arg7?: any, arg8?: any): void;
}

export interface IAgent {
}
/** 커넥션에이전트의 모든 결과 또는 알림 인터페이스 */
export interface IConnectionListener {
    /**
     * Connect()의 결과
     * @param connection Connect()을 요청한 커넥션에이전트
     * @param resultCode 연결의 결과 코드
     */
    OnConnect?(connection: ConnectionAgent, resultCode: ResultCodeConnect): void;
    /**
     * Authentication()의 결과
     * @param connection Authentication()을 요청한 커넥션에이전트
     * @param resultCode 인증의 결과 코드
     * @param loginedUserInfoList 서버에 남아있는 로그인 정보 목록
     * @param message 서버로부터 받은 메세지, 인증 실패 이유 등
     * @param payload 서버로 부터 받은 추가 정보
     */
    OnAuthentication?(connection: ConnectionAgent, resultCode: ResultCodeAuth, loginedUserInfoList: Array<LoginedUserInfo>, message: string, payload: Payload): void;
    /**
     * GetChannelList()의 결과
     * @param connection GetChannelList()를 요청한 커넥션에이전트
     * @param resultCode GetChannelList()의 결과 코드
     * @param channelIdList 체널 목록
     */
    OnChannelList?(connection: ConnectionAgent, resultCode: ResultCodeChannelList, channelIdList: Array<string>): void;
    /**
     * GetChannelInfo()의 결과
     * @param connection GetChannelInfo()를 요청한 커넥션에이전트
     * @param resultCode GetChannelInfo()의 결과 코드
     * @param channelInfo 체널 정보
     */
    OnChannelInfo?(connection: ConnectionAgent, resultCode: ResultCodeChannelInfo, channelInfo: Payload): void;
    /**
     * GetChannelCountInfo()의 결과
     * @param connection GetChannelCountInfo()를 요청한 커넥션에이전트
     * @param resultCode GetChannelCountInfo()의 결과 코드
     * @param channelCountInfo 체널의 유저와 방 개수
     */
    OnChannelCountInfo?(connection: ConnectionAgent, resultCode: ResultCodeChannelCountInfo, channelCountInfo: ChannelCountInfo): void;
    /**
     * GetAllChannelInfo()의 결과
     * @param connection GetAllChannelInfo()를 요청한 커넥션에이전트
     * @param resultCode GetAllChannelInfo의 결과 코드
     * @param allChannelInfo 체널 정보
     */
    OnAllChannelInfo?(connection: ConnectionAgent, resultCode: ResultCodeAllChannelInfo, allChannelInfo: AllChannelInfo): void;
    /**
     * GetAllChannelCountInfo()의 결과
     * @param connection GetAllChannelCountInfo()를 요청한 커넥션에이전트
     * @param resultCode GetAllChannelCountInfo()의 결과 코드
     * @param channelInfoList 체널의 유저와 방 개수
     */
    OnAllChannelCountInfo?(connection: ConnectionAgent, resultCode: ResultCodeAllChannelCountInfo, allChannelCountInfo: AllChannelCountInfo): void;
    /**
     * Disconnect()의 결과 또는 또는 강제 접속종료 알림
     * @param connection Disconnect()를 요청한 커넥션에이전트
     * @param resultCode Disconnect()의 결과 코드
     * @param reason 종료 이유. ConnectionAgent.Disconnect()에 인자로 넘긴 이유
     * @param force 강제 종료 여부
     * @param payload 서버로 부터 받은 추가 정보
     */
    OnDisconnect?(connection: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload): void;
    /**
     * 오류 발생
     * @param connection 오류 발생 한 커넥션에이전트
     * @param errorCode 에러 코드
     * @param msgName 에러가 발생한 메세지의 이름
     */
    OnErrorCommand?(connection: ConnectionAgent, errorCode: ErrorCode, msgName: string): void;
}
/** 유저리스너에서 Login()의 결과를 위한 인터페이스 */
export interface IUserListener {
    /**
     * Login()의 결과
     * @param user Login()을 요청한 유저에이전트
     * @param resultCode Login() 결과 코드
     * @param loginInfo Login() 정보
     */
    OnLogin?(user: UserAgent, resultCode: ResultCodeLogin, loginInfo: LoginInfo): void;
    /**
     * Logout()의 결과
     * @param user Logout()을 요청한 유저에이전트
     * @param resultCode  Logout() 결과 코드
     * @param force 강제 로그아웃여부
     * @param payload 서버로 부터 받은 추가정보
     */
    OnLogout?(user: UserAgent, resultCode: ResultCodeLogout, force: boolean, payload: Payload): void;
    /**
     * MatchRoom()의 결과
     * @param user MatchRoom()을 요청한 유저에이전트
     * @param resultCode MatchRoom() 결과 코드
     * @param roomId 매치된 방의 룸아이디
     * @param roomName 매치된 방의 이름
     * @param created 매치된 방의 생성여부(방장 여부)
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnMatchRoom?(user: UserAgent, resultCode: ResultCodeMatchRoom, roomId: number, roomName: string, created: boolean, payload: Payload): void;
    /**
     * CreateRoom()의 결과
     * @param user CreateRoom()을 요청한 유저에이전트
     * @param resultCode CreateRoom() 결과 코드
     * @param roomId 생성된 방의 룸아이디
     * @param roomName 생성된 방의 이름
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnCreateRoom?(user: UserAgent, resultCode: ResultCodeCreateRoom, roomId: number, roomName: string, payload: Payload): void;
    /**
     * JoinRoom()의 결과
     * @param user JoinRoom()을 요청한 유저에이전트
     * @param resultCode JoinRoom() 결과 코드
     * @param roomId 입장한 방의 룸아이디
     * @param roomName 입장한 방의 이름
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnJoinRoom?(user: UserAgent, resultCode: ResultCodeJoinRoom, roomId: number, roomName: string, payload: Payload): void;
    /**
     * NamedRoom()의 결과
     * @param user NamedRoom()을 요청한 유저에이전트
     * @param resultCode NamedRoom() 결과 코드
     * @param roomId 입장한 방의 룸아이디
     * @param roomName 입장한 방의 이름
     * @param created 입장한 방을 생성했는지 여부(방장 여부)
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnNamedRoom?(user: UserAgent, resultCode: ResultCodeNamedRoom, roomId: number, roomName: string, created: boolean, payload: Payload): void;
    /**
     * LeaveRoom()의 결과
     * @param user LeaveRoom()을 요청한 유저에이전트
     * @param resultCode LeaveRoom() 결과 코드
     * @param force 강퇴 여부
     * @param roomId 퇴장한 방의 룸아이디
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnLeaveRoom?(user: UserAgent, resultCode: ResultCodeLeaveRoom, force: boolean, roomId: number, payload: Payload): void;
    /**
     * MatchUserStart()의 결과
     * @param user MatchUserStart()를 요청한 유저에이전트
     * @param resultCode MatchUserStart() 결과 코드
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnMatchUserStart?(user: UserAgent, resultCode: ResultCodeMatchUserStart, payload: Payload): void;
    /**
     * MatchUserCancel()의 결과
     * @param user MatchUserCancel()을 요청한 유저에이전트
     * @param resultCode MatchUserCancel() 결과 코드
     */
    OnMatchUserCancel?(user: UserAgent, resultCode: ResultCodeMatchUserCancel): void;
    /**
     * MatchUserStart(), MatchPartyStart()의 매칭 결과
     * @param user 매칭을 요청한 유저에이전트
     * @param resultCode 매칭 결과 코드
     * @param created 방 생성 여부. true일 경우 매칭 요청한 UserAgent가  방을 생성한 것을 의미한다. 방장을 결정하는 용도 등으로 사용할 수 있음
     * @param roomId 매칭된 방의 룸아이디
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnMatchUserDone?(user: UserAgent, resultCode: ResultCodeMatchUserDone, created: boolean, roomId: number, payload: Payload): void;
    /**
     * MatchUserStart(), MatchPartyStart()의 매칭의 타임아웃시 발생
     * @param user 매칭을 요청한 유저에이전트
     */
    OnMatchUserTimeout?(user: UserAgent): void;
    /**
     * MatchPartyStart()의 결과
     * @param user MatchPartyStart()을 요청한 유저에이전트
     * @param resultCode MatchPartyStart() 결과 코드
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMatchPartyStart?(user: UserAgent, resultCode: ResultCodeMatchPartyStart, payload: Payload): void;
    /**
     * MatchPartyCancel()의 결과
     * @param user MatchPartyCancel()을 요청한 유저에이전트
     * @param resultCode MatchPartyCancel()의 결과 코드
     */
    OnMatchPartyCancel?(user: UserAgent, resultCode: ResultCodeMatchPartyCancel): void;
    /**
     * MoveChannel()의 결과 또는 서버에서 강제로 수행한 체널 이동 알림
     * @param user 체널을 이동한 유저에이전트
     * @param resultCode 체널이동 결과 코드
     * @param force 서버에서 강제로 체널을 이동했는지 여부
     * @param channelId 이동한 체널아이디
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnMoveChannel?(user: UserAgent, resultCode: ResultCodeMoveChannel, force: boolean, channelId: string, payload: Payload): void;
    /**
     * Snapshot()의 결과
     * @param user Snapshot()을 요청한 유저에이전트
     * @param resultCode Snapshot()의 결과 코드
     * @param payload 서버로 부터 받은 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnSnapshot?(user: UserAgent, resultCode: ResultCodeSnapshot, payload: Payload): void;
    /**
     * GetChannelInfo()의 결과
     * @param user GetChannelInfo()를 요청한 유저에이전트
     * @param resultCode GetChannelInfo()의 결과 코드
     * @param channelInfo 체널 정보
     */
    OnChannelInfo?(user: UserAgent, resultCode: ResultCodeChannelInfo, channelInfo: Payload): void;
    /**
     * GetChannelCountInfo()의 결과
     * @param user GetChannelCountInfo()를 요청한 유저에이전트
     * @param resultCode GetChannelCountInfo()의 결과 코드
     * @param channelCountInfo 체널의 유저와 방 개수
     */
    OnChannelCountInfo?(user: UserAgent, resultCode: ResultCodeChannelCountInfo, channelCountInfo: ChannelCountInfo): void;
    /**
     * GetAllChannelInfo()의 결과
     * @param user GetAllChannelInfo()를 요청한 유저에이전트
     * @param resultCode GetAllChannelInfo()의 결과 코드
     * @param allChannelInfo 체널 정보
     */
    OnAllChannelInfo?(user: UserAgent, resultCode: ResultCodeAllChannelInfo, allChannelInfo: AllChannelInfo): void;
    /**
     * GetAllChannelCountInfo()의 결과
     * @param user GetAllChannelCountInfo()를 요청한 유저에이전트
     * @param resultCode GetAllChannelCountInfo()의 결과 코드
     * @param channelInfoList 체널의 유저와 방 개수
     */
    OnAllChannelCountInfo?(user: UserAgent, resultCode: ResultCodeAllChannelCountInfo, allChannelCountInfo: AllChannelCountInfo): void;
    /**
     * 오류 발생
     * @param user 오류가 발생한 유저에이전트
     * @param errorCode 오류 코드
     * @param msgName 오류가 발생한 기능 또는 메세지
     */
    OnErrorCommand?(user: UserAgent, errorCode: ErrorCode, msgName: string): void;
    /**
     * 공지 알림
     * @param user 공지 를 받은 유저에이전트
     * @param message 공지 메세지
     */
    OnNotice?(user: UserAgent, message: string): void;
    /**
     * 어드민에서 Kickout()한 경우 알림
     * @param user Kickout()된 유저에이전트
     * @param message 어드민에서 전달한 메세지
     */
    OnAdminKickoutNoti?(user: UserAgent, message: string): void;
    /**
     * 유저리스너에서 서버의 세션이 닫힌 경우 알림. 이 알람을 받을 경우 다시 로그인하여 재시작 필요
     * @param user 세션이 닫힌 유저에이전트
     * @param resultCode 세션이 닫힌 이유
     * @param paload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     */
    OnSessionCloseNoti?(user: UserAgent, resultCode: ResultCodeSessionClose, payload: Payload): void;
}

/**
 * 내부용 이므로 사용하면 안된다.
*/
export class EventCallbackByMsgId {
    constructor(isVolatile: boolean);
    Clear(): void;
    Add<T extends IMessage>(msg: IMessage | (new () => T), callback: any, keyForCallback?: any): void;
    AddWithMsgId(msgId: number, callback: any, keyForCallback?: any): void;
    Remove<T extends IMessage>(msg: IMessage | (new () => T), callback?: any): void;
    RemoveWithMsgId(msgId: number, callback?: any): void;
    Contains<T extends IMessage>(msg: IMessage | (new () => T), callback?: any): boolean;
    ContainsWithMsgId(msgId: number, callback?: any): boolean;
    Call(msgId: number, arg1: any, arg2?: any, arg3?: any, arg4?: any, arg5?: any, arg6?: any, arg7?: any, arg8?: any): void;
}

/**
 * GameAnvil 서버의 Space Node와 관련된 작업을 담당
 *
 * 로그인(Login()), 로그아웃(Logout()) 및 방 관리 등 기본 기능을 제공하며, 서버 구현에 따라 사용자 정의 기능을 추가적으로 제공
 *
 * Connector.CreateUserAgent() 함수로 새로운 유저 에이전트를 생성
 *
 * 서비스 이름과 서브아이디로 구분되는 여러개의 유저 에이전트를 생성할 수 있으며 각 유저 에이전트는 독립적으로 사용 가능
 *
 * 생성된 유저 에이전트는 커넥터에서 내부적으로 관리되며 Connector.GetUser()함수로 각 에이전트 객체에 접근 가능
 *
 * UserAgent가 제공하는 기본 기능은 모두 비동기 함수를 통해 제공하며 기능의 결과를 얻기 위한 두 가지 방식이 존재
 *
 * 리스너나 대리자를 미리 등록해 놓고 결과에 대한 알림을 받는 방법과 기능을 사용 할 때 알림을 받을 대리자를 같이 전달하는 방법의 두 가지 방식 제공
 *
 * 두 가지 방법을 혼용해 사용하는 것이 가능, 리스너나 대리자는 여러 개 등록 가능
 */
export class UserAgent {
    /**
     * 로그인 여부를 확인
     * @returns 로그인 한경우 true, 아닐경우 false
     */
    IsLogin(): boolean;
    /**
     * 인증시 사용한 어카운트아이디를 반환
     * @returns 인증시 사용한 어카운트아이디
     */
    GetAccountId(): string;
    /**
     * 로그인한 서비스이름을 반환
     * @returns 로그인한 서비스이름
     */
    GetServiceName(): string;
    /**
     * 로그인한 유저타입을 반환
     * @returns 로그인한 유저타입
     */
    GetUserType(): string;
    /**
     * 로그인한 서브아이디를 반환
     * @returns 로그인한 서브아이디
     */
    GetSubId(): number;
    /**
     * 로그인한 유저아이디를 반환
     * @returns 로그인한 유저아이디
 */
    GetUserId(): number;
    /**
     * 로그인한 체널의 채널아이디 반환
     * @returns 로그인한 체널아이디
 */
    GetChannelId(): string;
    /**
     * 임의의 데이터를 설정
     * @param userData 임의의 데이터
     */
    SetUserData(userData: any): void;
    /**
     * SetUserData()로 설정한 임의의 데이터를 반환
     * @returns 설정된 임의의 데이터
     */
    GetUserData(): any;
    /**
     * 유저 매칭 진행 여부를 확인
     * @returns 유저 매칭이 진행중인 경우 true, 아닐경우 false
     */
    IsMatchUserInProgress(): boolean;
    /**
     * 파티 매칭 진행 여부를 확인
     * @returns 파티 매칭이 진행중인 경우 true, 아닐경우 false
     */
    IsMatchPartyInProgress(): boolean;
    /**
     * 유저 또는 파티  매칭 진행 여부를 확인
     * @returns 유저 또는 파티 매칭이 진행중인 경우 true, 아닐경우 false
     */
    IsMatchInProgress(): boolean;
    /**
     * 메세지 아이디에 대한 콜백을 등록
     *
     * 해당 메세지 아이디의 패킷을 수신한 경우 등록된 콜백이 호출
     * @param resMsgId 응답으로 받을 패킷의 메세지 아이디
     * @param callback 응답을 받을 경우 호출될 콜백
     */
    AddCallback(resMsgId: number, callback: (agent: UserAgent, packet: Packet) => void): void;
    /**
     * 특정 메세지에 대한 콜백을 등록
     *
     * 특정 메세지의 패킷을 수신한 경우 등록된 콜백이 호출
     * @param message 응답으로 받을 패킷에 담긴 메세지
     * @param callback 응답을 받을 경우 호출될 콜백
     */
    AddCallback<T extends IMessage>(message: new () => T, callback: (agent: UserAgent, msg: T) => void): void;
    /**
     * 메세지 아이디에 대한 콜백이 등록되어있는지 확인
     * @param resMsgId 확인할 패킷의 메세지 아이디
     * @param callback 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsCallback(resMsgId: number, callback?: (agent: UserAgent, packet: Packet) => void): boolean;
    /**
     * 특정 메세지에 대한 콜백이 등록되어있는지 확인
     * @param message 확인할 메세지
     * @param callback 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsCallback<T extends IMessage>(message: new () => T, callback?: (agent: UserAgent, msg: T) => void): boolean;
    /**
     * 메세지 아이디 대해 등록한 모든 콜백을 등록 해제하거나 입력 받은 콜백을 등록해제
     * @param resMsgId 등록한 메세지 아이디
     * @param callback 입력하지 않을 경우 모든 콜백, 입력 할 경우 입력한 콜백을 등록 해제
     */
    RemoveCallback(resMsgId: number, callback?: (agent: UserAgent, packet: Packet) => void): any;
    /**
     * 특정 메세지에 대해 등록한 모든 콜백을 등록 해제
     * @param message 등록한 메세지
     * @param callback 입력하지 않을 경우 모든 콜백, 입력 할 경우 입력한 콜백을 등록 해제
     */
    RemoveCallback<T extends IMessage>(message: new () => T, callback?: (agent: UserAgent, msg: T) => void): void;
    /**
     * 등록한 모든 콜백을 등록 해제
     */
    RemoveAllCallback(): void;
    /**
     * IUserListener를 상속받은 유저리스너를 등록
     * @param listener IUserListener를 상속받은 유저리스너
     */
    AddListener(listener: IUserListener): void;
    /**
     * 유저리스너가 등록되었는지 확인
     * @param listener 확인할 유저리스너. 입력 할 경우 입력한 유저리스너의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsListener(listener?: IUserListener): boolean;
    /**
     * 등록한 유저리스너를 등록 해제
     * @param listener 등록한 유저리스너. 입력 할 경우 입력한 유저리스너를 등록 해제, 입력하지 않을 경우 모든 유저리스너 등록 해제
     */
    RemoveListener(listener?: IUserListener): void;
    /**
     * 서버로 패킷 목록 전송
     * @param packets 서버로 보낼 패킷 목록
     */
    MultiSend(packets: Array<Packet>): void;
    /**
     * 서버의 세션으로 패킷 콕록 전송
     * @param packets 서버로 보낼 패킷 콕록
     */
    MultiSendToGatewaySession(packets: Array<Packet>): void;
    /**
     * 서버로 패킷을 전송
     * @param packet 서버로 보낼 패킷
     */
    Send(packet: Packet): void;
    /**
     * 서버의 세션으로 패킷을 전송
     * @param packet 서버로 보낼 패킷
     */
    SendToGatewaySession(packet: Packet): void;
    /**
     * 서버로 메세지를 담은 패킷 전송
     * @param reqMsg 서버로 보낼 메세지
     */
    SendPb<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버의 세션으로 메세지를 담은 패킷 전송
     * @param reqMsg 서버로 보낼 메세지
     */
    SendPbToGatewaySession<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버로 패킷 목록를 보내고 응답을 대기
     *
     * 응답을 받기위해 AddCallback()으로 응답으로 올 패킷또는 메세지에 대해 미리 콜백을 등록
     * @param packets 서버로 보낼 패킷 목록
     */
    MultiRequest(packets: Array<Packet>): void;
    /**
     * 서버의 세션으로 패킷 목록를 보내고 응답을 대기
     *
     * 응답을 받기위해 AddCallback()으로 응답으로 올 패킷또는 메세지에 대해 미리 콜백을 등록
     * @param packets 서버로 보낼 패킷
     */
    MultiRequestToGatewaySession(packets: Array<Packet>): void;
    /**
     * 서버로 패킷을 보내고 응답을 대기
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 콜백 (선택 사항)
     */
    Request(packet: Packet, callback?: (userAgent: UserAgent, packet: Packet) => void): void;
    /**
     * 서버의 세션으로 패킷을 보내고 응답을 대기
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 콜백 (선택 사항)
     */
    RequestToGatewaySession(packet: Packet, callback?: (userAgent: UserAgent, packet: Packet) => void): void;
    /**
     * 서버로 메세지를 담은 패킷 보내고 응답을 대기
     * @param reqMsg 서버로 보낼 메세지
     * @param callback 응답을 받을 경우 호출될 콜백 (선택 사항)
     */
    RequestPb<T extends IMessage>(reqMsg: IMessage, callback?: (userAgent: UserAgent, resMsg: T) => void): void;
    /**
     * 서버의 세션으로 메세지를 담은 패킷 보내고 응답을 대기
     * @param reqMsg 서버로 보낼 메세지
     * @param callback 응답을 받을 경우 호출될 콜백 (선택 사항)
     */
    RequestPbToGatewaySession<T extends IMessage>(reqMsg: IMessage, callback?: (userAgent: UserAgent, resMsg: T) => void): void;
    /**
     * 서버로 메세지를 담은 패킷 보내고 응답을 대기
     *
     * RequestPb()의 비동기 버전
     * @typeparam T 응답으로 받을 메세지의 타입
     * @param reqMsg 서버로 보낼 메세지
     * @returns 응답으로 받은 메세지
     */
    RequestPbAsync<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버의 세션으로 메세지를 담은 패킷 보내고 응답을 대기
     *
     * RequestPbToGatewaySession()의 비동기 버전
     * @typeparam T 응답으로 받을 메세지의 타입
     * @param reqMsg 서버로 보낼 메세지
     * @returns 응답으로 받은 메세지
     */
    RequestPbAsyncToGatewaySession<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버로 패킷 보내고 응답을 대기
     *
     * Request()의 비동기 버전
     * @param packet 서버로 보낼 패킷
     * @returns 응답으로 받은 패킷
     */
    RequestAsync(packet: Packet): Promise<Packet>;
    /**
     * 서버의 세션으로 패킷 보내고 응답을 대기
     *
     * RequestToGatewaySession()의 비동기 버전
     * @param packet 서버로 보낼 패킷
     * @returns 응답으로 받은 패킷
     */
    RequestAsyncToGatewaySession(packet: Packet): Promise<Packet>;
    /**
     * 오류 발생시 호출될 콜백을 등록
     * @param callback 오류발생시 호출될 콜백
     */
    AddOnError(callback: (agent: UserAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * 오류발생시 호출될 콜백이 등록되었는지 확인
     * @param callback 오류발생시 호출될 콜백. 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsOnError(callback?: (agent: UserAgent, errorCode: ErrorCode, command: string) => void): boolean;
    /**
     * 등록한 모든 오류발생시 호출될 콜백을 등록 해제
     * @param callback 등록한 콜백. 입력 할 경우 입력한 콜백 해제, 입력하지 않은 경우 등록된 모든 콜백 등록 해제
     */
    RemoveOnError(callback?: (agent: UserAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * 서버에 로그인
     * @param userType 로그인에 사용할 유저타입
     * @param payload 서버에 전달 할 추가정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param channelId 로그인 할 채널아이디
     * @param callback 로그인 결과를 전달받아 처리 할 콜백
     */
    Login(userType: string, payload?: Payload, channelId?: string, callback?: (agent: UserAgent, resultCode: ResultCodeLogin, loginInfo: LoginInfo) => void): void;
    /**
     * 서버에 로그인
     *
     * Login()의 비동기 버전
     * @param userType 로그인에 사용할 유저타입
     * @param payload 서버에 전달 할 추가정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param channelId 로그인 할 채널아이디
     * @returns 요청 결과
     */
    LoginAsync(userType: string, payload?: Payload, channelId?: string): Promise<LoginPromise>;
    /**
     * 룸 매치를 요청
     *
     * 룸이 없을 경우 임의의 방을 생성하고 해당 방에 입장할 수도 있음
     * @param isCreateRoomIfNotJoinRoom true - 입장할 룸이 없을 경우 임의의 룸을 생성후 입장. false - 입장할 룸이 없을 경우 실패
     * @param isMoveRoomIfJoinedRoom true - 룸에 입장한 상태에서 요청했을 경우 다른 룸으로 이동. false - 룸에 입장한 상태에서 요청했을 경우 실패
     * @param roomType 입장할 방의 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param leaveRoomPayload 입장한 룸을 떠날때 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 룸매치 결과를 전달받아 처리 할 콜백
     */
    MatchRoom(isCreateRoomIfNotJoinRoom: boolean, isMoveRoomIfJoinedRoom: boolean, roomType: string, payload?: Payload, leaveRoomPayload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchRoom, roomId: number, roomName: string, created: boolean, payload: Payload) => void): void;
    /**
     * 룸 매치를 요청
     *
     * 방이 없을 경우 임의의 방을 생성하고 해당 방에 입장할 수도 있음
     *
     * MatchRoom()의 비동기 버전
     * @param isCreateRoomIfNotJoinRoom true - 입장할 룸이 없을 경우 임의의 룸을 생성후 입장. false - 입장할 룸이 없을 경우 실패
     * @param isMoveRoomIfJoinedRoom true - 룸에 입장한 상태에서 요청했을 경우 다른 룸으로 이동. false - 룸에 입장한 상태에서 요청했을 경우 실패
     * @param roomType 입장할 방의 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param leaveRoomPayload 입장한 룸을 떠날때 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    MatchRoomAsync(isCreateRoomIfNotJoinRoom: boolean, isMoveRoomIfJoinedRoom: boolean, roomType: string, payload?: Payload, leaveRoomPayload?: Payload): Promise<MatchRoomPromise>;
    /**
     * 임의의 방을 생성하고 해당 방에 입장
     * @param roomType 생성할 방의 룸타입
     * @param roomName 생성할 방의 이름
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 방 생성 결과를 전달 받아 처리 할 콜백
     */
    CreateRoom(roomType: string, roomName: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeCreateRoom, roomId: number, roomName: string, payload: Payload) => void): void;
    /**
     * 임의의 방을 생성하고 해당 방에 입장
     *
     * CreateRoom()의 비동기 버전
     * @param roomType 생성할 방의 룸타입
     * @param roomName 생성할 방의 이름
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    CreateRoomAsync(roomType: string, roomName: string, payload?: Payload): Promise<CreateRoomPromise>;
    /**
     * 지정한 룸아이디의 방에 입장
     *
     * 지정한 룸아이디의 방이 없을 경우 실패
     * @param roomId 입장하고자 하는 룸아이디
     * @param roomType 입장할 방의 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 방 입장 결과를 전달받아 처리 할 콜백
     */
    JoinRoom(roomId: number, roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeJoinRoom, roomId: number, roomName: string, payload: Payload) => void): void;
    /**
     * 지정한 룸아이디의 방에 입장
     *
     * 지정한 룸아이디의 방이 없을 경우 실패
     *
     * JoinRoom()의 비동기 버전
     * @param roomId 입장하고자 하는 방의 아이디
     * @param roomType 입장할 방의 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    JoinRoomAsync(roomId: number, roomType: string, payload?: Payload): Promise<JoinRoomPromise>;
    /**
     * 방에 입장했는지 여부를 반환
     * @returns 방에 입장했을 경우 true, 아닐경우 false
     */
    IsJoinedRoom(): boolean;
    /**
     * 지정한 이름의 방에 입장
     *
     * 지정한 이름의 방이 없을 경우 지정한 이름의 방을 생성하고 해당 방에 입장
     * @param roomName 입장하고자 하는 방의 이름
     * @param roomType 입장할 방의 룸타입
     * @param isParty true - 파티 매칭을 목적으로 만들어진 방. false - 일반 방
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 네임드룸 처리 결과를 전달받아 처리 할 콜백
     */
    NamedRoom(roomName: string, roomType: string, isParty: boolean, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeNamedRoom, roomId: number, roomName: string, created: boolean, payLoad: Payload) => void): void;
    /**
     * 지정한 이름의 방에 입장
     *
     * 지정한 이름의 방이 없을 경우 지정한 이름의 방을 생성하고 해당 방에 입장
     *
     * NamedRoom()의 비동기 버전
     * @param roomName 입장하고자 하는 방의 이름
     * @param roomType 입장할 방의 룸타입
     * @param isParty true - 파티 매칭을 목적으로 만들어진 방. false - 일반 방
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    NamedRoomAsync(roomName: string, roomType: string, isParty: boolean, payload?: Payload): Promise<NamedRoomPromise>;
    /**
     * 파티 매치를 요청
     * @param roomType 매치를 요청할 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 파티 매치 요청 결과를 전달받아 처리 할 콜백
     */
    MatchPartyStart(roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchPartyStart, payload: Payload) => void): void;
    /**
     * 파티매치를 요청한다
     *
     * MatchPartyStart()의 Async 버전
     * @param roomType 매치를 요청할 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    MatchPartyStartAsync(roomType: string, payload?: Payload): Promise<MatchPartyStartPromise>;
    /**
     * 파티매치 요청을 취소
     * @param roomType 매치를 요청한 룸타입
     * @param callback 파티매치 취소 쵸청 결과를 전달받아 처리 할 콜백
     */
    MatchPartyCancel(roomType: string, callback?: (agent: UserAgent, resultCode: ResultCodeMatchPartyCancel) => void): void;
    /**
     * 파티매치 요청을 취소
     *
     * MatchPartyCancel()의 비동기 버전
     * @param roomType 매치를 요청한 룸타입
     * @returns 요청 결과
     */
    MatchPartyCancelAsync(roomType: string): Promise<ResultCodeMatchPartyCancel>;
    /**
     * 유저매치를 요청
     *
     * 이미 방에 입장한 경우 등 서버의 조건에 따라 요청이 실패할 수 있음
     *
     * 매칭이 성공한 경우 OnMatchUserDone()을 통해 알림을 받을 수 있음
     * @param roomType 매치를 요청할 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 유저 매치 요청 결과를 전달받아 처리 할 콜백
     */
    MatchUserStart(roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchUserStart, payLoad: Payload) => void): void;
    /**
     * 유저매치를 요청
     *
     * 이미 방에 입장한 경우 등 서버의 조건에 따라 요청이 실패할 수 있음
     *
     * 매칭이 성공한 경우 OnMatchUserDone을 통해 알림을 받을 수 있음
     *
     * MatchUserStart()의 비동기 버전
     * @param roomType 매치를 요청할 룸타입
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    MatchUserStartAsync(roomType: string, payload?: Payload): Promise<MatchUserStartPromise>;
    /**
     * 유저매치 요청을 취소
     *
     * 매치 요청중이 아닌경우나 이미 매칭이 성공했거나 타임아웃이 발생했을 경우는 실패
     * @param roomType 매치를 요청한 룸타입
     * @param callback 유저매치 취소 요청 결과를 전달 받아 처리 할 콜백
     */
    MatchUserCancel(roomType: string, callback?: (agent: UserAgent, resultCode: ResultCodeMatchUserCancel) => void): void;
    /**
     * 우저매치 요청을 취소
     *
     * 매치 요청중이 아닌경우나 이미 매칭이 성공했거나 타임아웃이 발생했을 경우 실패
     *
     * MatchUserCancel의 비동기 버전
     * @param roomType 매치를 요청한 룸타입
     * @returns 요청 결과
     */
    MatchUserCancelAsync(roomType: string): Promise<ResultCodeMatchUserCancel>;
    /**
     * 현재 방에서 나가기
     * @param payload 서버에 전달할 추가 정보.서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 방나가기 요청 결과를 전달받아 처리 할 콜백
     */
    LeaveRoom(payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeLeaveRoom, roomId: number, payload: Payload) => void): void;
    /**
     * 현재 방에서 나가기
     *
     * LeaveRoom()의 비동기 버전
     * @param payload 서버에 전달할 추가 정보.서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    LeaveRoomAsync(payload?: Payload): Promise<LeaveRoomPromise>;
    /**
     * 지정한 채널로 이동
     * @param channelId 이동할 채널아이디
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 채널 이동 결과를 전달받아 처리 할 콜백
     */
    MoveChannel(channelId: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMoveChannel, channelId: string, payload: Payload) => void): void;
    /**
     * 지정한 채널로 이동
     *
     * MoveChannel()의 비동기 버전
     * @param channelId 이동할 채널아이디
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    MoveChannelAsync(channelId: string, payload?: Payload): Promise<MoveChannelPromise>;
    /**
     * 현재 유저의 임시저장 정보를 얻어오기
     *
     * 재접속 등 유저의 모든 정보를 갱싱해야 할 필요가 있을때 사용
     *
     * 서버 구현에 따라 내용이 달라 질수 있음
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @param callback 이시저장 정보 요청 결과를 전달받아 처리 할 콜백
     */
    SnapShot(payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeSnapshot, payload: Payload) => void): void;
    /**
     * 현재 유저의 임시저장 정보를 얻어오기
     *
     * 재접속 등 유저의 모든 정보를 갱싱해야 할 필요가 있을때 사용
     *
     * 서버 구현에 따라 내용이 달라 질수 있음
     * SnapShot()의 비동기 버전
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음
     * @returns 요청 결과
     */
    SnapShotAsync(payload?: Payload): Promise<SnapShotPromise>;
    /**
     * 접속중인 채널 정보를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param callback 채널 정보 요청 결과를 전달받아 처리 할 콜백
     */
    GetChannelInfo(callback?: (agent: UserAgent, resultCode: ResultCodeChannelInfo, channelInfo: Payload) => void): void;
    /**
     * 특정 채널의 정보를 요청
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param channelId 채널 정보를 요청할 채널아이디
     * @param callback 채널 정보 요청 결과를 전달받아 처리 할 콜백
     */
    GetChannelInfo(serviceName: string, channelId: string, callback?: (agent: UserAgent, resultCode: ResultCodeChannelInfo, channelInfo: Payload) => void): void;
    /**
     * 접속중인 채널의 정보를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelInfo()의 비동기 버전
     * @returns 요청 결과
     */
    GetChannelInfoAsync(): Promise<GetChannelInfoPromise>;
    /**
     * 특정 채널의 정보를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param channelId 채널 정보를 요청할 채널이름
     * @returns 요청 결과
     */
    GetChannelInfoAsync(serviceName: string, channelId: string): Promise<GetChannelInfoPromise>;
    /**
     * 접속중인 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param callback 채널의 유저와 방 개수 요청 결과를 전달받아 처리 할 콜백
     */
    GetChannelCountInfo(callback?: (agent: UserAgent, resultCode: ResultCodeChannelCountInfo, channelCountInfo: ChannelCountInfo) => void): void;
    /**
     * 특정 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param channelId 채널 정보를 요청할 채널아이디
     * @param callback 채널의 유저와 방 개수 요청 결과를 전달받아 처리 할 콜백
     */
    GetChannelCountInfo(serviceName: string, channelId: string, callback?: (agent: UserAgent, resultCode: ResultCodeChannelCountInfo, channelCountInfo: ChannelCountInfo) => void): void;
    /**
     * 접속중인 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelCountInfo()의 비동기 버전
     * @returns 요청 결과
     */
    GetChannelCountInfoAsync(): Promise<GetChannelCountInfoPromise>;
    /**
     * 특정 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelCountInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param channelId 채널 정보를 요청할 채널아이디
     * @returns 요청 결과
     */
    GetChannelCountInfoAsync(serviceName: string, channelId: string): Promise<GetChannelCountInfoPromise>;
    /**
     * 접속중인 서비스의 모든 채널정보 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param callback 모든 채널 정보 요청 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelInfo(callback?: (agent: UserAgent, resultCode: ResultCodeAllChannelInfo, allChannelInfo: AllChannelInfo) => void): void;
    /**
     * 특정 서비스의 모든 채널정보 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스아름
     * @param callback 모든 채널 정보 요청 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelInfo(serviceName: string, callback?: (agent: UserAgent, resultCode: ResultCodeAllChannelInfo, allChannelInfo: AllChannelInfo) => void): void;
    /**
     * 접속중인 서비스의 모든 채널정보 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetAllChannelInfo()의 비동기 버전
     * @returns 요청 결과
     */
    GetAllChannelInfoAsync(): Promise<GetAllChannelInfoPromise>;
    /**
     * 특정 서비스의 모든 채널 정보 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetAllChannelInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @returns 요청 결과
     */
    GetAllChannelInfoAsync(serviceName: string): Promise<GetAllChannelInfoPromise>;
    /**
     * 접속중인 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param callback 모든 채널의 유저와 방의 개수 요청 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelCountInfo(callback?: (agent: UserAgent, resultCode: ResultCodeAllChannelCountInfo, allChannelCountInfo: AllChannelCountInfo) => void): void;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @param callback 모든 채널의 유저와 방의 개수 요청 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelCountInfo(serviceName: string, callback?: (agent: UserAgent, resultCode: ResultCodeAllChannelCountInfo, allChannelCountInfo: AllChannelCountInfo) => void): void;
    /**
     * 접속중인 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetAllChannelCountInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @returns 요청 결과
     */
    GetAllChannelCountInfoAsync(): Promise<GetAllChannelCountInfoPromise>;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetAllChannelCountInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스이름
     * @returns 요청 결과
     */
    GetAllChannelCountInfoAsync(serviceName: string): Promise<GetAllChannelCountInfoPromise>;
    /**
     * 현재 서비스에서 로그아웃
     * @param callback 로그아웃 결과를 전달받아 처리 할 콜백
     */
    Logout(callback?: (agent: UserAgent, resultCode: ResultCodeLogout, payload: Payload) => void): void;
    /**
     * 현재 서비스에서 로그아웃
     *
     * Logout()의 비동기 버전
     * @returns 요청 결과
     */
    LogoutAsync(): Promise<LogoutPromise>;
}
/**
 * 로그인 정보
 */
export class LoginInfo {
    /** 로그인한 유저의 아이디 */
    userId: number;
    /** 로그인한 유저의 타입 */
    userType: string;
    /** 로그인한 체널의 아이디 */
    channelId: string;
    /** 로그인한 서비스의 이름 */
    serviceName: string;
    /** 서버로부터 받은 추가정보 */
    payload: Payload;
    /** 재로그인 여부 */
    isRelogined: boolean;
    /** 방에 입장 여부 */
    isJoinedRoom: boolean;
    /** 입장한 방의 룸아이디 */
    roomId: number;
    /** 입장한 방의 룸이름 */
    roomName: string;
    /** 입장한 방에 필요한 추가정보 */
    roomPayload: Payload;
    /** 매칭을 요청한 상태인지 여부 */
    isMatching: boolean;
    constructor(
    /** 로그인한 유저의 아이디 */
    userId: number, 
    /** 로그인한 유저의 타입 */
    userType: string, 
    /** 로그인한 체널의 아이디 */
    channelId: string, 
    /** 로그인한 서비스의 이름 */
    serviceName: string, 
    /** 서버로부터 받은 추가정보 */
    payload: Payload, 
    /** 재로그인 여부 */
    isRelogined: boolean, 
    /** 방에 입장 여부 */
    isJoinedRoom: boolean, 
    /** 입장한 방의 룸아이디 */
    roomId: number, 
    /** 입장한 방의 룸이름 */
    roomName: string, 
    /** 입장한 방에 필요한 추가정보 */
    roomPayload: Payload, 
    /** 매칭을 요청한 상태인지 여부 */
    isMatching: boolean);
}
/** LoginAsync() 결과 */
export class LoginPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLogin;
    /** 로그인 정보 */
    loginInfo: LoginInfo;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeLogin, 
    /** 로그인 정보 */
    loginInfo: LoginInfo);
}
/** MatchRoomAsync() 결과 */
export class MatchRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchRoom;
    /** 매치된 방의 RoomId  */
    roomId: number;
    /** 매치된 방의 이름  */
    roomName: string;
    /** 매치된 방의 생성 여부(방장 여부)  */
    created: boolean;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeMatchRoom, 
    /** 매치된 방의 RoomId  */
    roomId: number, 
    /** 매치된 방의 이름  */
    roomName: string, 
    /** 매치된 방의 생성 여부(방장 여부)  */
    created: boolean, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** CreateRoomAsync() 결과 */
export class CreateRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeCreateRoom;
    /** 생성한 방의 RoomId */
    roomId: number;
    /** 생성한 방의 이름 */
    roomName: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeCreateRoom, 
    /** 생성한 방의 RoomId */
    roomId: number, 
    /** 생성한 방의 이름 */
    roomName: string, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** JoinRoomAsync() 결과 */
export class JoinRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeJoinRoom;
    /** 입장한 방의 RoomId */
    roomId: number;
    /** 입장한 방의 이름 */
    roomName: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeJoinRoom, 
    /** 입장한 방의 RoomId */
    roomId: number, 
    /** 입장한 방의 이름 */
    roomName: string, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** NamedRoomAsync() 결과 */
export class NamedRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeNamedRoom;
    /** 입장한 방의 RoomId */
    roomId: number;
    /** 입장한 방의 이름 */
    roomName: string;
    /** 입장한 방을 생성했는지 여부(방장 여부) */
    created: boolean;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeNamedRoom, 
    /** 입장한 방의 RoomId */
    roomId: number, 
    /** 입장한 방의 이름 */
    roomName: string, 
    /** 입장한 방을 생성했는지 여부(방장 여부) */
    created: boolean, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** MatchPartyStartAsync() 결과 */
export class MatchPartyStartPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchPartyStart;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeMatchPartyStart, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** MatchUserStartAsync() 결과 */
export class MatchUserStartPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchUserStart;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeMatchUserStart, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** LeaveRoomAsync 결과 */
export class LeaveRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLeaveRoom;
    /** 퇴장한 방의 RoomId */
    roomId: number;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeLeaveRoom, 
    /** 퇴장한 방의 RoomId */
    roomId: number, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload);
}
/** MoveChannelAsync 결과 */
export class MoveChannelPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMoveChannel;
    /** 이동한 체널의 ChannelId */
    channelId: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeMoveChannel, 
    /** 이동한 체널의 ChannelId */
    channelId: string, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** LogoutAsync 결과 */
export class LogoutPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLogout;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeLogout, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}
/** SnapShotAsync 결과 */
export class SnapShotPromise {
    /** 결과 코드 */
    resultCode: ResultCodeSnapshot;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeSnapshot, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음 */
    payload: Payload);
}

/**
 * GameAnvil 서버의 커넥션 노드와 관련된 작업을 담당
 *
 * 접속, 인증 등 기본 세션 관리 기능과 채널 목록 제공
 *
 * 서버 구현에 따라 채널 정보를 제공하거나 사용자 정의 기능을 추가로 제공
 *
 * 커넥터가 초기화 될 때 자동으로 생성되며, 커넥터의 GetConnectionAgent() 함수를 통해 커넥션 에이전트에 접근
 *
 * 기능 요청을 위해 비동기 함수를 호출한 후 동작의 결과를 나중에 전달 받는 방식
 *
 * 리스너와 대리자를 미리 등록해 각 기능 시도 결과를 전달받거나, 기능 요청 시에 대리자를 같이 전달
 *
 * 리스너와 대리자는 여러개 등록 가능
 */
export class ConnectionAgent {
    /**
     * 인증시 사용한 계정 아이디 반환
     * @returns 인증시 사용한 계정 아이디
     */
    GetAccountId(): string;
    /**
     * 서버 접속 여부 확인
     * @returns 서버에 접속한 경우 true, 아닌 경우 false
     */
    IsConnected(): boolean;
    /**
     * 응답 처리할 메세지 아이디에 대한 콜백을 등록
     *
     * 등록한 메세지 아이디의 패킷을 수신한 경우 등록된 콜백이 호출
     * @param resMsgId 응답으로 받을 메세지 아이디
     * @param callback 등록 처리할 콜백
     */
    AddCallback(resMsgId: number, callback: (agent: ConnectionAgent, packet: Packet) => void): void;
    /**
 * 프로토 버프 타입의 메세지에 대한 콜백을 등록
 *
 * 등록한 메세지 패킷을 수신한 경우 등록된 콜백이 호출
 * @param message 응답으로 받을 메세지
 * @param callback 등록 처리할 콜백
 */
    AddCallback<T extends IMessage>(message: new () => T, callback: (agent: ConnectionAgent, msg: T) => void): void;
    /**
     * 메세지 아이디에 대한 콜백이 등록 되어 있는지 확인
     * @param resMsgId 확인할 메세지 아이디
     * @param callback 확인 할 콜백. 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     * @returns 등록한 경우 true, 아닌 경우 false
     */
    ContainsCallback(resMsgId: number, callback?: (agent: ConnectionAgent, packet: Packet) => void): boolean;
    /**
     * 프로토 버프 메세지에 대한 콜백이 등록되어있는지 확인
     * @param message 확인할 메세지
     * @param callback 확인 할 콜백. 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     * @returns 등록한 경우 true, 아닌 경우 false
     */
    ContainsCallback<T extends IMessage>(message: new () => T, callback?: (agent: ConnectionAgent, msg: T) => void): boolean;
    /**
     * 메세지 아이디에 대해 등록한 모든 콜백을 등록 해제 하거나 입력받은 콜백을 등록 해제
     * @param resMsgId 등록한 메세지 아이디
     * @param callback 해제할 콜백. 입력하지 않을 경우 모든 콜백, 입력 할 경우 입력한 콜백을 등록 해제.
     */
    RemoveCallback(resMsgId: number, callback?: (agent: ConnectionAgent, packet: Packet) => void): void;
    /**
     * 프로토 버프 메세지에 대해 등록한 모든 콜백을 등록 해제
     * @param message 등록한 메세지
     * @param callback 해제할 콜백. 입력하지 않을 경우 모든 콜백, 입력 할 경우 입력한 콜백을 등록 해제
     */
    RemoveCallback<T extends IMessage>(message: new () => T, callback?: (agent: ConnectionAgent, msg: T) => void): void;
    /**
     * IConnectionListener 상속받은 리스너를 등록
     * @param listener 등록할 IConnectionListener를 상속받은 리스너
     */
    AddListener(listener: IConnectionListener): void;
    /**
     * 커넥션 리스너가 등록되었는지 확인
     * @param listener 확인할 커넥션 리스너. 입력 할 경우 입력한 커넥션 리스너의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsListener(listener?: IConnectionListener): boolean;
    /**
     * 등록한 커넥션 리스너를 등록 해제
     * @param listener 해제 할 커넥션 리스너. 입력하지 않을 경우 모든 커넥션 리스너, 입력 할 경우 입력한 커넥션 리스너 등록 해제.
     */
    RemoveListener(listener?: IConnectionListener): void;
    /**
     * 서버로 패킷을 전송
     * @param packet 서버로 보낼 패킷
     */
    Send(packet: Packet): void;
    /**
     * 서버로 프로토 버프 메세지를 전송
     * @param reqMsg 서버로 보낼 메세지
     */
    SendPb<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버로 패킷을 보내고, 응답을 대기
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 콜백
     */
    Request(packet: Packet, callback?: (agent: ConnectionAgent, packet: Packet) => void): void;
    /**
     * 서버로 프로토 메세지를 보내고, 응답을 대기
     * @param msg 서버로 보낼 메세지
     * @param callback 응답을 받을 경우 호출될 콜백
     */
    RequestPb<T extends IMessage>(msg: IMessage, callback?: (agent: ConnectionAgent, resMsg: T) => void): void;
    /**
     * 서버로 프로토 버프 메세지를 보내고, 응답을 대기
     *
     * RequestPb()의 비동기 버전
     * @typeparam T 응답으로 받을 프로토 버프 메세지의 타입
     * @param reqMsg 서버로 보낼 메세지
     * @returns 응답으로 받은 메세지
     */
    RequestPbAsync<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버로 패킷 보내고, 응답을 대기
     *
     * Request()의 비동기 버전
     * @param packet 서버로 보낼 패킷
     * @returns 응답으로 받은 패킷
     */
    RequestAsync(packet: Packet): Promise<Packet>;
    /**
     * 오류 발생시 호출될 콜백을 등록
     * @param callback 오류발생시 호출될 콜백
     */
    AddOnError(callback: (agent: ConnectionAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * 오류 발생시 호출될 콜백이 등록되었는지 확인
     * @param callback 오류 발생시 호출될 콜백. 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsOnError(callback?: (agent: ConnectionAgent, errorCode: ErrorCode, command: string) => void): boolean;
    /**
     * 등록한 오류 발생시 호출될 콜백을 등록 해제
     * @param callback 등록한 콜백. 입력 할 경우 입력한 콜백 해제, 입력하지 않은 경우 등록된 모든 콜백 등록 해제
     */
    RemoveOnError(callback?: (agent: ConnectionAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * GameAnvil 서버에 연결
     * @param ipAdress 연결할 서버의 주소 (ws://127.0.0.1:18300/gameanvil)
     * @param callback 결과를 전달받아 처리할 콜백
     */
    Connect(ipAdress: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeConnect) => void): void;
    /**
     * GameAnvil 서버에 연결
     *
     * Connect()의 비동기 버전
     * @param ipAdress 연결할 서버의 주소 (ws://127.0.0.1:18300/gameanvil)
     * @returns 결과 코드
     */
    ConnectAsync(ipAdress: string): Promise<ResultCodeConnect>;
    /**
     * GameAnvil 서버에 인증을 요청
     *
     * 인증에 성공해야 GameAnvil 커넥터의 다른 기능을 사용 가능
     * @param deviceId 사용자 기기를 식별 할 수 있는 고유 아이디. 같은 사용자의 중복 접속을 체크하는데 사용
     * @param accountId 사용자 계정을 식별 할 수 있는 고유 아이디
     * @param password 사용자 계정의 패스워드
     * @param payload 서버로 전달 할 추가 정보
     * @param callback 결과를 전달 받아 처리 할 콜백
     */
    Authenticate(deviceId: string, accountId: string, password: string, payload?: Payload, callback?: (agent: ConnectionAgent, resultCode: ResultCodeAuth, loginedUserInfoList: Array<LoginedUserInfo>, message: string, payload: Payload) => void): void;
    /**
     * GameAnvil 서버에 인증을 요청
     *
     * 인증에 성공해야 GameAnvil 커넥터의 다른 기능을 사용 가능
     *
     * Authenticate()의 비동기 버전
     * @param deviceId 사용자 기기를 식별 할 수 있는 고유 아이디. 같은 사용자의 중복 접속을 체크하는데 사용
     * @param accountId 사용자 계정을 식별 할 수 있는 고유 아이디
     * @param password 사용자 계정의 패스워드
     * @param payload 서버로 전달 할 추가 정보
     * @returns 인증 요청 결과
     */
    AuthenticateAsync(deviceId: string, accountId: string, password: string, payload?: Payload): Promise<AuthenticatePromis>;
    /**
     * 특정 서비스에서 사용 가능한 채널 목록을 요청
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param callback 결과를 전달 받아 처리 할 콜백
     */
    GetChannelList(serviceName: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeChannelList, channelIdList: Array<string>) => void): void;
    /**
     * 특정 서비스에서 사용 가능한 채널 목록을 요청
     *
     * GetChannelList()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @returns 채널 목록을 요청 결과
     */
    GetChannelListAsync(serviceName: string): Promise<GetChannelListPromis>;
    /**
     * 특정 채널의 정보를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param channelId 채널 정보를 요청할 체널의 아이디
     * @param callback 결과를 전달받아 처리 할 콜백
     */
    GetChannelInfo(serviceName: string, channelId: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeChannelInfo, channelInfo: Payload) => void): void;
    /**
     * 특정 채널의 정보를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param channelId 채널 정보를 요청할 체널의 아아디
     * @returns 채널의 정보를 요청 결과
     */
    GetChannelInfoAsync(serviceName: string, channelId: string): Promise<GetChannelInfoPromise>;
    /**
     * 특정 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param channelId 채널 정보를 요청할 체널의 아이디
     * @param callback 결과를 전달받아 처리 할 콜백
     */
    GetChannelCountInfo(serviceName: string, channelId: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeChannelCountInfo, channelCountInfo: ChannelCountInfo) => void): void;
    /**
     * 특정 채널의 유저와 방 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetChannelCountInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param channelId 채널 정보를 요청할 체널의 아이디
     * @returns 채널의 정보를 요청 결과
     */
    GetChannelCountInfoAsync(serviceName: string, channelId: string): Promise<GetChannelCountInfoPromise>;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param callback 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelInfo(serviceName: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeAllChannelInfo, allChannelInfo: AllChannelInfo) => void): void;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * GetAllChannelInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @returns 채널의 정보를 요청 결과
     */
    GetAllChannelInfoAsync(serviceName: string): Promise<GetAllChannelInfoPromise>;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @param callback 결과를 전달받아 처리 할 콜백
     */
    GetAllChannelCountInfo(serviceName: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeAllChannelCountInfo, allChannelCountInfo: AllChannelCountInfo) => void): void;
    /**
     * 특정 서비스에 있는 모든 채널의 유저와 방의 개수를 요청
     *
     * 서버에서 지원할 경우 사용할 수 있음
     *
     * AllChannelCountInfo()의 비동기 버전
     * @param serviceName 채널 정보를 요청할 서비스의 이름
     * @returns 채널의 정보를 요청 결과
     */
    GetAllChannelCountInfoAsync(serviceName: string): Promise<GetAllChannelCountInfoPromise>;
    /**
     * 접속 종료시 호출될 콜백을 등록
     * @param callback 접속 종료시 호출될 콜백
     */
    AddOnDisconnect(callback: (agent: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload) => void): void;
    /**
     * 접속 종료시 호출될 콜백이 등록되었는지 확인
     * @param callback 접속 종료시 호출될 콜백. 입력 할 경우 입력한 콜백의 등록 여부, 입력하지 않은 경우 하나 이상 등록 여부
     */
    ContainsOnDisconnect(callback?: (agent: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload) => void): boolean;
    /**
     * 등록한 접속 종료시 호출될 콜백을 등록 해제
     * @param callback 등록한 콜백. 입력 할 경우 입력한 콜백 등록 해제, 입력하지 않은 경우 등록된 모든 콜백 등록 해제
     */
    RemoveOnDisconnect(callback?: (agent: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload) => void): void;
    /**
     * GameAnvil 서버와의 연결을 해제
     * @param reason 콜백에 전달할 연결 해제 이유
     * @param callback 접속 종료시 호출될 콜백
     */
    Disconnect(reason: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string) => void): void;
    /**
     * GameAnvil 서버와의 연결을 해제
     * Disconnect()의 비동기 버전
     * @param reason 연결 해제 이유
     */
    DisconnectAsync(reason: string): Promise<DisconnectPromise>;
}
/**
 * 인증 성공시, 서버에 남아있는 로그인된 유저정보
 */
export class LoginedUserInfo {
    /** 서브아이디 */
    subId: number;
    /** 서비스 이름 */
    serviceName: string;
    /** 유저 아이디 */
    userId: number;
    /** 유저 타입 */
    userType: string;
    /** 채널 아이디 */
    channelId: string;
    constructor(
    /** 서브아이디 */
    subId: number, 
    /** 서비스 이름 */
    serviceName: string, 
    /** 유저 아이디 */
    userId: number, 
    /** 유저 타입 */
    userType: string, 
    /** 채널 아이디 */
    channelId: string);
}
/**
 * AuthenticateAsync()의 요청 결과
 */
export class AuthenticatePromis {
    /** 결과 코드 */
    resultCode: ResultCodeAuth;
    /** 서버에 남아있는 로그인 정보 목록 */
    loginedUserInfoList: Array<LoginedUserInfo>;
    /** 서버로부터 받은 메세지. 인증 실패 이유 등 */
    message: string;
    /** 추가 정보 */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeAuth, 
    /** 서버에 남아있는 로그인 정보 목록 */
    loginedUserInfoList: Array<LoginedUserInfo>, 
    /** 서버로부터 받은 메세지. 인증 실패 이유 등 */
    message: string, 
    /** 추가 정보 */
    payload: Payload);
}
/**
 * GetChannelListAsync()의 요청 결과
 */
export class GetChannelListPromis {
    /** 결과 코드 */
    resultCode: ResultCodeChannelList;
    /** 체널 목록 */
    channelIdList: Array<string>;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeChannelList, 
    /** 체널 목록 */
    channelIdList: Array<string>);
}
/**
 * GetChannelInfoAsync()의 요청 결과
 */
export class GetChannelInfoPromise {
    /** 결과 코드 */
    resultCode: ResultCodeChannelInfo;
    /** 체널 정보 목록 */
    channelInfo: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeChannelInfo, 
    /** 체널 정보 목록 */
    channelInfo: Payload);
}
/**
 * GetChannelCountInfoAsync() 의 요청 결과
 */
export class GetChannelCountInfoPromise {
    /** 결과 코드 */
    resultCode: ResultCodeChannelCountInfo;
    /** 채널의 유저와 방 개수 정보 */
    channelCountInfo: ChannelCountInfo;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeChannelCountInfo, 
    /** 채널의 유저와 방 개수 정보 */
    channelCountInfo: ChannelCountInfo);
}
/**
 * GetAllChannelInfoAsync()의 요청 결과
 */
export class GetAllChannelInfoPromise {
    /** 결과 코드 */
    resultCode: ResultCodeAllChannelInfo;
    /** 모든 체널 정보 */
    allChannelInfo: AllChannelInfo;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeAllChannelInfo, 
    /** 모든 체널 정보 */
    allChannelInfo: AllChannelInfo);
}
/**
 * GetAllChannelCountInfoAsync()의 요청 결과
 */
export class GetAllChannelCountInfoPromise {
    /** 결과 코드 */
    resultCode: ResultCodeAllChannelCountInfo;
    /** 모든 체널 정보 */
    allChannelCountInfo: AllChannelCountInfo;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeAllChannelCountInfo, 
    /** 모든 체널 정보 */
    allChannelCountInfo: AllChannelCountInfo);
}
/**
 * DisconnectAsync()의 요청 결과
 */
export class DisconnectPromise {
    result: ResultCodeDisconnect;
    reason: string;
    constructor(result: ResultCodeDisconnect, reason: string);
}


/**
 * 커넥터 환경값.
 */
export class Config {
    /**
     * 타임아웃 기본 대기시간 설정(단위 : 초, 기본값 3)
     */
    DefaultRequestTimeout: number;
    /**
     * 서버와의 연결을 확인하기 위한 확인 주기 설정(단위 : 초, 0일 경우 사용 안함, 기본값 : 3)
     */
    PingInterval: number;
    /**
     * 패킷이 지정된 시간안에 업데이트 되지 않으면, 연결해제 되었다고 판단
     * pingInterval 보다 높게 설정  필요 (기본값 : 5)
     */
    PacketTimeout: number;
    /**
     * 함수 호출시 callback을 인자로 넣어 호출할 경우 인자로 받은 callback만 호출 (기본값 : true)
     * @deprecated This option is obsolete and will be deprecated soon. The value 'false' is unavailable.
     */
    useArgumentCallbackOnly: boolean;
}

/**
 * 커넥터는 GameAnvil 서버와 연결 하고 통신하기 위한 기본 클래스
 *
 * 기본 설정과 에이전트의 관리를 담당
 */
export class Connector {
    /**
	     * 커넥터 환경값
	     */
     config: Config;
     /**
      * 커넥터의 새 인스턴스를 생성하여 반환
      * @returns 커넥터의 새 인스턴스
      */
     static Create(): Connector;
     /**
      * 유저 에이전트 생성
      * @param serviceName 유저에이전트가 사용 할 서비스 이름
      * @param subId 서비스별 유저에이전트를 식별 할 수 있는 고유 아이디. 서버 구현에 따라 사용하지 않을 수 있음
      * @returns 생성된 유저 에이전트
      */
     CreateUserAgent(serviceName: string, subId: number): UserAgent;
     /**
      * 모든 유저 에이전트를 반환
      * @returns 모든 유저 에이전트 목록
      */
     GetUserAgents(): Array<UserAgent>;
     /**
      * 서비스이름과 서브 아이디에 해당하는 유저 에이전트를 반환
      * @param serviceName 유저에이전트가 사용하는 서비스이름
      * @param subId 서비스별 유저에이전트를 식별 할 수 있는 고유 아아디. 서버 구현에 따라 사용하지 않을 수 있음
      * @returns 해당 유저 에이전트, 없으면 null
      */
     GetUserAgent(serviceName: string, subId: number): UserAgent;
     /**
      * 컨넥션 에이전트를 반환
      * @returns 컨넥션 에이전트
      */
     GetConnectionAgent(): ConnectionAgent;
     /**
      * 메세지의 처리를 위한 함수
      *
      * 주기적으로 호출 필요
      */
    Update(): void;
}